<?php

namespace common\components;
use Yii;
use yii\base\Component;
use yii\helpers\ArrayHelper;
use \DateTime;
class AgeCandidateConditionComponent extends Component
{

    public function CandidateAgeCondition($candidatepost)
    {

    

        $CandidateID = Yii::$app->user->identity->ID;
        $GenderID = Yii::$app->user->identity->GenderID;
        $Pwd = Yii::$app->user->identity->PhysicalDisability;
        $CastCategoryID = Yii::$app->user->identity->CastCategoryID;
        $CandidateDOB = Yii::$app->user->identity->DOB;


        $applicationStatus = Yii::$app->ApplicationOpen->Openwindow();
        $correctionStatus = Yii::$app->CorrectionWindow->Openwindow();

        if (isset($applicationStatus, $correctionStatus) && ($applicationStatus == 0) && ($correctionStatus == 1)) {

            $CandidateCorrectionDataByCol = Yii::$app->masterdata->getCorrectionDataByCol('PersonalDetails');

            if(isset($CandidateCorrectionDataByCol) && !empty($CandidateCorrectionDataByCol)){
                $GenderID = $CandidateCorrectionDataByCol['GenderID'];
                $Pwd = $CandidateCorrectionDataByCol['PhysicalDisability'];
                $CastCategoryID = $CandidateCorrectionDataByCol['CastCategoryID'];
                $CandidateDOB = $CandidateCorrectionDataByCol['DOB'];
            }

        }
     
        $CandCastCategoryData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'CategoryCode')
            ->bindValue(':input', 'WHERE ID=' . $CastCategoryID)
            ->bindValue(':table', 'CasteCategoryMst')
            ->queryOne();


        $CandApplyCourseData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'CourseCode')
            ->bindValue(':input', 'WHERE IsActive=1 and ID=' . $candidatepost)
            ->bindValue(':table', 'CourseMst')
            ->queryOne();

        $CandGenderData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'GenderCode')
            ->bindValue(':input', 'WHERE ID=' . $GenderID)
            ->bindValue(':table', 'GenderMst')
            ->queryOne();


        if (isset($CandCastCategoryData) && !empty($CandCastCategoryData) && isset($CandGenderData) 
        && !empty($CandGenderData) && isset($CandApplyCourseData) && !empty($CandApplyCourseData) ) {

            if ($CandApplyCourseData['CourseCode'] == 'C001') {

                $cand_cast_category = $CandCastCategoryData['CategoryCode'];
                $cand_gender = $CandGenderData['GenderCode'];
                $cand_is_pwd = (($Pwd == 1) || ($Pwd == 2)) ? 'yes' : 'no';


                // $cand_dob = date('Y-m-d', strtotime(Yii::$app->user->identity->DOB));

                $cand_dob = date('Y-m-d', strtotime($CandidateDOB));

                $max_age_as_on_time_of_registration_date = date('Y-m-d', strtotime(yii::$app->params['MAX_AGE_AS_ON_TIME_OF_REGISTRATION_DATE']));

                $cand_age_calculated_as_on_date = $this->ageCalculatorAsOnGivendate($cand_dob, $max_age_as_on_time_of_registration_date);

                //print_r($cand_age_calculated_as_on_date);die;

                $general_generalEws_maxAgeVal =  yii::$app->params['general_generalEws_maxAgeVal'];//24;

                $obcNcl_maxAgeVal =  yii::$app->params['obcNcl_maxAgeVal'];//24;

                $sc_st_thirdGender_pwd_female_maxAgeVal =  yii::$app->params['sc_st_thirdGender_pwd_female_maxAgeVal'];//29;
                //Age criteria condition check:
                //11111111
                //if(($cand_gender == 'F') || ($cand_gender == 'THRDGEN') || ($cand_is_pwd == 'yes')){

                if(($cand_is_pwd == 'yes')){
                    if($this->checkAgeAsOnDate($cand_age_calculated_as_on_date, $sc_st_thirdGender_pwd_female_maxAgeVal)){
                        //return 'sc_st_thirdGender_pwd_female_maxAgeVal<=29';
                        return true;
                    } else {
                        //return 'sc_st_thirdGender_pwd_female_maxAgeVal>29';
                        return false;
                    }
                }
                //2222222
                if(($cand_cast_category == 'SC') || ($cand_cast_category == 'ST')){

                    if($this->checkAgeAsOnDate($cand_age_calculated_as_on_date, $sc_st_thirdGender_pwd_female_maxAgeVal)){

                        //return 'sc_st_thirdGender_pwd_female_maxAgeVal<=29';
                        return true;
                    } else {
                        //return 'sc_st_thirdGender_pwd_female_maxAgeVal>29';
                        return false;
                    } 
                }
                //33333333
                if(($cand_cast_category == 'GENERAL') || ($cand_cast_category == 'GENEWS')){
                    if($this->checkAgeAsOnDate($cand_age_calculated_as_on_date, $general_generalEws_maxAgeVal)){
                        //return 'general_generalEws_maxAgeVal<=24';
                        return true;
                    } else {
                        //return 'general_generalEws_maxAgeVal>24';
                        return false;
                    } 
                }
                //444444444
                if($cand_cast_category == 'OBCNCL'){
                    if($this->checkAgeAsOnDate($cand_age_calculated_as_on_date, $obcNcl_maxAgeVal)){
                        //return 'obcNcl_maxAgeVal<=24';
                        return true;
                    } else {
                        //return 'obcNcl_maxAgeVal>24';
                        return false;
                    } 
                }
                return false;
            } else {
                return true;
            }
        }
        return false;

    }


   Protected function ageCalculatorAsOnGivendate($dob, $max_age_as_on_time_date)
    {
        if (!empty($dob)) {
            //$max_age_as_on_time_date = date('Y-m-d', strtotime($max_age_as_on_time_date));
            $birthdate = new DateTime($dob);
            $asOnGivendate   = new DateTime($max_age_as_on_time_date);
            $ageYear = $birthdate->diff($asOnGivendate)->y;
            $ageMonth = $birthdate->diff($asOnGivendate)->m;
            $ageDays = $birthdate->diff($asOnGivendate)->d;
            $result = [
                'ageYear' => $ageYear,
                'ageMonth' => $ageMonth,
                'ageDays' => $ageDays,
            ];
            return $result;
        } else {
            return 0;
        }
    }

    Protected function checkAgeAsOnDate($cand_age_calculated_as_on_date, $MAX_AGE_AS_ON_DATE, $exp=0)
    {
        //Compare Age:
        if (($cand_age_calculated_as_on_date != null) && ($MAX_AGE_AS_ON_DATE != null)) {
            $age_year = $cand_age_calculated_as_on_date['ageYear'];
            //if($exp > 0){
            //    $age_year = $cand_age_calculated_as_on_date['ageYear'] + $exp;
            //}
            $age_month = $cand_age_calculated_as_on_date['ageMonth'];
            $age_days = $cand_age_calculated_as_on_date['ageDays'];
            if ($age_year > $MAX_AGE_AS_ON_DATE) {
                return false;
            }
            if ($age_year < $MAX_AGE_AS_ON_DATE) {
                return true;
            }
            if ($age_year == $MAX_AGE_AS_ON_DATE) {
                if (($age_month > 0) || ($age_days > 0)) {
                    return false;
                }
                return true;
            }
            return false;
        }
    }


}
