<?php

namespace common\components;
use Yii;
use yii\base\Component;
use MicrosoftAzure\Storage\Blob\BlobRestProxy;
use MicrosoftAzure\Storage\Blob\Models\CreateBlockBlobOptions;
use MicrosoftAzure\Storage\Common\Exceptions\ServiceException;

class AzureFileUploadComponent extends Component
{
    public function uploadDocument($applicationNumber, $selectFile, $documentCode, $type,$folderName=null)
    {
         $file = $selectFile;
        $connectionString = Yii::$app->params['connectionString'];
        $containerName = Yii::$app->params['containerName'];
        $filename= $file->name;
        $extension=pathinfo($filename, PATHINFO_EXTENSION);
        $fileType= $file->type;
        $fileTempPath= $file->tempName;
        $blobName= $applicationNumber.'/'. $documentCode.'_'.time().'.'. $extension;
        if(!empty($folderName)){
            $blobName = $folderName.'/'.$applicationNumber . '/' . $documentCode . '_' . time() . '.' . $extension;

        }
       // $running = time();
        
        //$mimeParts = explode('/', $type);
        //$extension = strtolower(end($mimeParts));

       // $docName = $filename . '_' . $running . '.' . $extension;
        //$blobName = $applicationNumber . '/' . $docName;

        try {
            // Create blob client
              $blobClient = BlobRestProxy::createBlobService($connectionString);
              $content = fopen($fileTempPath, "r");
              $blobClient->createBlockBlob($containerName, $blobName, $content);
           // $blobName='sachin';;
              $isBlobExists=  $blobClient->getBlob($containerName, $blobName);
              if($isBlobExists){
                $response['Status'] = 1;
                $response['filename'] = $blobName;
                $response['msg'] = 'File Uploaded Successfully.';
                return json_encode($response); 
              }else{
                $response['Status'] = 0;
                $response['filename'] = null;
                $response['msg'] = 'Something went wrong.';
                return json_encode($response); 

              }

        } catch (ServiceException $e) {
            // Handle exception based on error codes and messages.
            $response['Status'] = 0;
            $response['filename'] = null;
            $response['msg'] = $e->getErrorText();
            return json_encode($response); 
        }
    }
    public function isDocumentPresent($blobName)
    {
        $connectionString = Yii::$app->params['connectionString'];
        $containerName = Yii::$app->params['containerName'];
        try {
            // Create blob client
            $blobClient = BlobRestProxy::createBlobService($connectionString);
            $isBlobExists =  $blobClient->getBlob($containerName, $blobName);
            if ($isBlobExists) {
                return 1;
            } else {
                
                return 0;
            }
        } catch (ServiceException $e) {
            return 0;
        }
    }
}
?>