<?php

namespace common\components;

use yii;
use yii\base\Component;


class HDFCEncryptDecryptComponent extends Component
{

    public function encrypt($plainText, $key)
    {
        $secretKey = $this->hextobin(md5($key));
        $initVector = pack("C*", 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f);
        $encryptedText = openssl_encrypt($plainText, "AES-128-CBC", $secretKey, OPENSSL_RAW_DATA, $initVector);
        $encryptedText = bin2hex($encryptedText);
        return $encryptedText;
    }

    public function decrypt($encryptedText, $key)
    {
        $secretKey         = $this->hextobin(md5($key));
        $initVector         =  pack("C*", 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f);
        $encryptedText      = $this->hextobin($encryptedText);
        $decryptedText         =  openssl_decrypt($encryptedText, "AES-128-CBC", $secretKey, OPENSSL_RAW_DATA, $initVector);
        return $decryptedText;
    }

    public function hextobin($hexString)
    {
        $length = strlen($hexString);
        $binString = "";
        $count = 0;
        while ($count < $length) {
            $subString = substr($hexString, $count, 2);
            $packedString = pack("H*", $subString);
            if ($count == 0) {
                $binString = $packedString;
            } else {
                $binString .= $packedString;
            }

            $count += 2;
        }
        return $binString;
    }
    public function pkcs5_pad($plainText, $blockSize)
    {
        $pad = $blockSize - (strlen($plainText) % $blockSize);
        return $plainText . str_repeat(chr($pad), $pad);
    }
    public function HDFC_RequestData()
    {
        $HDFC_DATA = [
            'merchant_id' => Yii::$app->params['HDFC_Config']['HDFC_Merchant_ID'],
            'language' => Yii::$app->params['HDFC_Config']['HDFC_Language'],
            'currency' => Yii::$app->params['HDFC_Config']['HDFC_Currency_TYPE'],
            'redirect_url' => Yii::$app->params['HDFC_Config']['HDFC_Response_URL'],
            'cancel_url' => Yii::$app->params['HDFC_Config']['HDFC_Cancle_URL'],
            'merchant_param1' => Yii::$app->user->identity->ID,
            'merchant_param2' => Yii::$app->params['HDFC_Config']['HDFC_Merchant_ID'],
        ];
        $request = json_encode($HDFC_DATA);
        return $HDFC_DATA;
    }
}
