<?php
namespace common\components;
use Yii;
use yii\base\Component;
//use yii\helpers\ArrayHelper;

class IciciPaymentComponent extends Component {

    const DEFAULT_BASE_URL = 'https://eazypayuat.icicibank.com/EazyPG?';
    
    public function getPaymentUrl($amount, $reference_no, $optional_field) {
        $optional_field = $optional_field='op|op';
        $iciciConfig = Yii::$app->params['IciciConfig'];
        $encryption_key = $iciciConfig['encryption_key'];
            //plain
        $enc_mandatory_field    =   $reference_no.'|'.$iciciConfig['sub_merchant_id'].'|'.$amount;
        $enc_optional_field     =   $optional_field;
        $enc_amount             =   $amount;
        $enc_reference_no       =   $reference_no;
        $enc_return_url         =   $iciciConfig['return_url'];
        $enc_sub_merchant_id    =   $iciciConfig['sub_merchant_id'];
        $enc_paymode            =   $iciciConfig['paymode'];
        
        $encryptedUrl = self::DEFAULT_BASE_URL."merchantid=".$iciciConfig['merchant_id'].
            "&mandatory fields=".$enc_mandatory_field."&optional fields=".$enc_optional_field.
            "&returnurl=".$enc_return_url."&Reference No=".$enc_reference_no.
            "&submerchantid=".$enc_sub_merchant_id."&transaction amount=".
            $enc_amount."&paymode=".$enc_paymode;
        return $encryptedUrl;
    }
    
    /*
     *  // Generate an initialization vector
     *  // $iv = openssl_random_pseudo_bytes(openssl_cipher_iv_length('aes-256-cbc'));
     *  // Encrypt the data using AES 128 encryption in ecb mode using our encryption key and initialization vector.
     *  // The $iv is just as important as the key for decrypting, so save it with our encrypted data using a unique separator (::)
     * 
     * 
    */
    protected function getEncryptValue($data, $encryption_key){
        $encrypted = openssl_encrypt($data, 'aes-128-ecb', $encryption_key, OPENSSL_RAW_DATA);
        return base64_encode($encrypted);
    }

    
    public function getIciciPaymentUrlQryString($amount, $reference_no, $optional_field) {
        $iciciConfig = Yii::$app->params['IciciConfig'];
        $encryption_key = $iciciConfig['encryption_key'];
        $enc_mandatory_field    =   $this->getEncryptValue($reference_no.'|'.$iciciConfig['sub_merchant_id'].'|'.$amount, $encryption_key);//$this->getMandatoryField($amount, $reference_no);
        $enc_optional_field     =   !is_null($optional_field) ? $this->getEncryptValue($optional_field, $encryption_key) : null;//$this->getOptionalField($optionalField);
        $enc_amount             =   $this->getEncryptValue($amount, $encryption_key);
        $enc_reference_no       =   $this->getEncryptValue($reference_no, $encryption_key);
        $enc_return_url         =   $this->getEncryptValue($iciciConfig['return_url'], $encryption_key);
        $enc_sub_merchant_id    =   $this->getEncryptValue($iciciConfig['sub_merchant_id'], $encryption_key);
        $enc_paymode            =   $this->getEncryptValue($iciciConfig['paymode'], $encryption_key);
        
        $encryptedQryString = "merchantid=".$iciciConfig['merchant_id'].
            "&mandatory fields=".$enc_mandatory_field."&optional fields=".$enc_optional_field.
            "&returnurl=".$enc_return_url."&Reference No=".$enc_reference_no.
            "&submerchantid=".$enc_sub_merchant_id."&transaction amount=".
            $enc_amount."&paymode=".$enc_paymode;
        return $encryptedQryString;
    }
    
    
}
?>