<?php

namespace common\components;

use yii;
use yii\base\Component;


class IdbiPaymentComponent extends Component
{
    public function Idbi_RequestData($data)
    {
        $data['Version'] = Yii::$app->params['IDBI_Config']['IDBI_VERSION'];
        $data['PassCode'] = Yii::$app->params['IDBI_Config']['IDBI_PASSCODE'];
        $data['BankId'] = Yii::$app->params['IDBI_Config']['IDBI_BANKID'];
        $data['MerchantId'] = Yii::$app->params['IDBI_Config']['IDBI_MERCHANTID'];
        $data['MCC'] = Yii::$app->params['IDBI_Config']['IDBI_MCC'];
        $data['TerminalId'] = Yii::$app->params['IDBI_Config']['IDBI_TERMINALID'];
        $data['ReturnURL'] = Yii::$app->params['IDBI_Config']['IDBI_RETURNURL'];
		
		$data['TxnType'] = Yii::$app->params['IDBI_Config']['IDBI_TxnType'];
		$data['Currency'] = Yii::$app->params['IDBI_Config']['IDBI_Currency'];
		$data['UDF01'] = '';
		//$data['UDF02'] = Yii::$app->user->identity->ID; 
		// $feeTotalAmount = Yii::$app->masterdata->getExamFeeByCandidateCastCategory();
        $feeTotalAmount = Yii::$app->PaymentCalculation->getExamFeeByCandidateCastCategory();
        $data['Amount'] = $feeTotalAmount*100; //Yii::$app->masterdata->getExamFeeByCandidateCastCategory();        
        //Remove Unwanted POST Variable
        unset($data["SubButL"]);
		//unset($data["payment_gateway_id"]);
        //------- sort on keys
        ksort($data);
        $dataToPostToPG=""; 
        foreach ($data as $key => $value) 
        {
            if("" == trim($value) && $value === NULL){
            //
            } else {
                    $dataToPostToPG=$dataToPostToPG.$key."||".($value)."::";
            }
        }
        //Generate Secure hash on parameters
        $SecureHash = $this->generateSecurehash($data);
        //Appending hash and data with ::
        $dataToPostToPG="SecureHash||".urlencode($SecureHash)."::".$dataToPostToPG;
        //Removing last 2 characters (::)
        $dataToPostToPG=substr($dataToPostToPG, 0, -2);
        
        return $dataToPostToPG;
    }
    public function Idbi_RequestDataParam()
    {
        $IDBI_DATA = [
            'IDBI_ENC_KEY' => Yii::$app->params['IDBI_Config']['IDBI_ENC_KEY'],
            'IDBI_SECURE_SECRET' => Yii::$app->params['IDBI_Config']['IDBI_SECURE_SECRET'],
            'IDBI_VERSION' => Yii::$app->params['IDBI_Config']['IDBI_VERSION'],
            'IDBI_PASSCODE' => Yii::$app->params['IDBI_Config']['IDBI_PASSCODE'],
            'IDBI_MERCHANTID' => Yii::$app->params['IDBI_Config']['IDBI_MERCHANTID'],
            'IDBI_BANKID' => Yii::$app->params['IDBI_Config']['IDBI_BANKID'],
            'IDBI_TERMINALID' => Yii::$app->params['IDBI_Config']['IDBI_TERMINALID'],
            'IDBI_MCC' => Yii::$app->params['IDBI_Config']['IDBI_MCC']
        ];
        return $IDBI_DATA;
    }
    function encrypt($input, $key) 
    {		
        return  base64_encode(openssl_encrypt($input,"AES-256-ECB", $key, OPENSSL_RAW_DATA ));
    }

    function decrypt($sStr, $key) 
    {		
        return  openssl_decrypt(base64_decode($sStr), 'AES-256-ECB', $key, OPENSSL_RAW_DATA);
    }	

    function generateSecurehash($sortedData)
    { 
        if($sortedData)
        {
            $SecureHash = Yii::$app->params['IDBI_Config']['IDBI_SECURE_SECRET'];//SECURE_SECRET;

            foreach($sortedData as $key => $val)
            {
                      $SecureHash = $SecureHash . ($val);

            }
        }
        //Generate SHA-256 hash
        $SecureHash = hash('sha256', utf8_encode($SecureHash));
        return $SecureHash;
    }

    function null2unknown($check_null,$Array_data)
    {
        if(!isset($Array_data[$check_null]))
        {
                return "No Value Returned";
        }
        else
        {
                return $Array_data[$check_null];
        }
    }
	
}
