<?php
namespace common\components;
use Yii;
use yii\base\Component;
class MailingComponent extends Component{
   /*
    * param :$templateName :Mail Template Name
    * param :$to : Recier email Id
    * param :$from : Sender Email Id 
    * param :$subject :Mail Subject
    * param :$content :Mail text content
   */
   public function commonmail($templateName,$to,$from,$subject,$content,$attachment = '',$ApplicationNumber=''){
        $message = Yii::$app->mailer->compose($templateName,
                ['message' => $content])
                ->setTo($to)
                ->setFrom([$from => Yii::$app->name])
                ->setSubject($subject);
        if(!empty($attachment) && isset($attachment)){
            $message->attachContent($attachment['attachment'], [
            'fileName'    => $ApplicationNumber.'_ApplicationForm',
            'contentType' => 'application/pdf'
            ]);    
        }
        return $message->send();
        
//        Yii::$app->mailer->compose($templateName,
//             ['message' => $content])
//        ->setTo($to)
//        ->setFrom($from)
//        ->setSubject($subject)
//        ->send();
        
    }   
		
    public function sendEmailForgot($CandidateName,$CandidateEmail, $EmailOtp,$emailForgotPasswordOtp_html, $emailForgotPasswordOtp_text)
    {
        $subject = "NTA-Forgot Password";
        return Yii::$app
            ->mailer
            ->compose(
                ['html' => $emailForgotPasswordOtp_html, 'text' => $emailForgotPasswordOtp_text],
                ['CandidateName' => $CandidateName,'EmailOtp'=>$EmailOtp]
            )
            ->setFrom([Yii::$app->params['supportEmail'] => Yii::$app->name])
            ->setTo($CandidateEmail)
            ->setSubject($subject)
            ->send();
    }

    public function sendEmailForOTP($CandidateName,$CandidateEmail, $EmailOtp,$emailForgotPasswordOtp_html, $emailForgotPasswordOtp_text)
    {
        $subject = "NTA Email OTP";
        return Yii::$app
            ->mailer
            ->compose(
                ['html' => $emailForgotPasswordOtp_html, 'text' => $emailForgotPasswordOtp_text],
                ['CandidateName' => $CandidateName,'EmailOtp'=>$EmailOtp]
            )
            ->setFrom([Yii::$app->params['supportEmail'] => Yii::$app->name])
            ->setTo($CandidateEmail)
            ->setSubject($subject)
            ->send();
    }

    public function sendMailContent($eventName,$variables,$CandidateEmail, $attachment = '',$ApplicationNumber=''){
		
//        $DB = Yii::$app->session->get('NewDB');
//        if (empty($DB)) {
//            return $this->redirect(['/site/login']);
//        }
        $mailData = Yii::$app->db->createCommand("exec getAdminMailContentData :EventName")
                    ->bindValue(':EventName', $eventName)
                    ->queryOne();
        foreach ($variables as $key => $val) {
            $varMap[$key] = $val;
        }
        $emailContent = strtr($mailData['MessageContent'], $varMap);
        $to = $CandidateEmail;
        $from = Yii::$app->params['supportEmail'];
        $subject = $mailData['Subject'];
        return Yii::$app->mailing->commonmail('mailTemplate-html', $to, $from, $subject, $emailContent, $attachment,$ApplicationNumber);
    }

}

?>