<?php

namespace common\components;

use Yii;
use yii\base\Component;
use yii\helpers\ArrayHelper;
use app\models\GenderMst;
use yii\helpers\FileHelper;
use app\models\CasteCategoryMst;
use app\models\AdminExamType;
use app\models\AdminExamCenterMst;
use app\models\CourseMst;
use app\models\SubjectMst;
use app\models\CityMst;
use app\models\StateMst;
use app\models\AdminExamConfigMst;
use \DateTime;
use Mpdf\Mpdf;

class MasterDataComponent extends Component
{

    public function genderList()
    {
        //$Gender_data = GenderMst::find()->where(['IsActive' => 1])->all();
        $Gender_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'ID,Gender')
            ->bindValue(':input', "WHERE IsActive=1")
            ->bindValue(':table', 'GenderMst')
            ->queryAll();
        return ArrayHelper::map($Gender_data, 'ID', 'Gender');
    }

    public function casteCategoryList()
    {
        //$Category_data = CasteCategoryMst::find()->where(['IsActive' => 1])->all();
        $Category_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'ID,CategoryName')
            ->bindValue(':input', "WHERE IsActive=1")
            ->bindValue(':table', 'CasteCategoryMst')
            ->queryAll();
        return ArrayHelper::map($Category_data, 'ID', 'CategoryName');
    }

    public function examTypeList()
    {
        //$ExamType_data = AdminExamType::find()->where(['IsActive' => 1])->all();

        $ExamType_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'ID,TypeName')
            ->bindValue(':input', "WHERE IsActive=1")
            ->bindValue(':table', 'AdminExamType')
            ->queryAll();
        return ArrayHelper::map($ExamType_data, 'ID', 'TypeName');
    }

    public function centerList($stateId = null, $cityId = null)
    {

        // $query = AdminExamCenterMst::find()->where(['IsActive' => 1]);        
        // if(isset($stateId) && $stateId !=''){
        //     $query->where(['StateID' => $stateId]);
        // }
        // if(isset($cityId) && $cityId !=''){
        //     $query->where(['CenterCityID' => $cityId]);
        // }
        // $Center_data = $query->all();
        $where = '';

        if (isset($stateId) && $stateId != '') {
            $where = ' and StateID=' . $stateId;
        }
        if (isset($cityId) && $cityId != '') {
            $where = ' and CenterCityID=' . $cityId;
        }

        $Center_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
            ->bindValue(':select', '*')
            ->bindValue(':input', 'WHERE IsActive=1' . $where)
            ->bindValue(':table', 'AdminExamCenterMst')
            ->bindValue(':orderBy', 'order By CenterName asc')
            ->queryAll();

        return ArrayHelper::map($Center_data, 'ID', 'CenterName');
    }

    public function courseList($opt = null)
    {
        //     $query = CourseMst::find()->where(['IsActive' => 1]);
        //     if(isset($opt) && $opt !='' && $opt != null){
        //         $query->where(['OptCourse' => $opt]);
        //     }
        //    $Course_data = $query->all();

        $where = '';
        if (isset($opt) && $opt != '') {
            $where = ' and OptCourse=' . $opt;
        }

        $Course_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
            ->bindValue(':select', '*')
            ->bindValue(':input', 'WHERE IsActive=1' . $where)
            ->bindValue(':table', 'CourseMst')
            ->bindValue(':orderBy', 'order By CourseName asc')
            ->queryAll();

        return ArrayHelper::map($Course_data, 'ID', 'CourseName');
    }

    public function subjectList()
    {

        //$Subject_data = SubjectMst::find()->where(['IsActive' => 1])->all();

        $Subject_data =  Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'ID,SubjectName')
            ->bindValue(':input', "WHERE IsActive=1")
            ->bindValue(':table', 'SubjectMst')
            ->queryAll();
        return ArrayHelper::map($Subject_data, 'ID', 'SubjectName');
    }

    public function cityList($stateId = null)
    {

        // $query = CityMst::find()->where(['IsActive' => 1]);
        // if(isset($stateId) && $stateId !=''){
        //     $query->where(['StateID' => $stateId]);
        // }
        // $city_data = $query->all();

        $where = '';
        if (isset($stateId) && $stateId != '') {
            $where = ' and StateID=' . $stateId;
        }
        $city_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
            ->bindValue(':select', '*')
            ->bindValue(':input', 'WHERE IsActive=1' . $where)
            ->bindValue(':table', 'CityMst')
            ->bindValue(':orderBy', 'order By CityName asc')
            ->queryAll();

        return ArrayHelper::map($city_data, 'ID', 'CityName');
    }

    public function stateList($countryId = null)
    {
        // $query = StateMst::find()->where(['IsActive' => 1]);
        // if(isset($countryId) && $countryId !=''){
        //     $query->where(['CountryID' => $countryId]);
        // }
        // $state_data = $query->orderBy(['StateName' => SORT_ASC])->all();

        $where = '';
        if (isset($countryId) && $countryId != '') {
            $where = ' and CountryID=' . $countryId;
        }
        $state_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
            ->bindValue(':select', '*')
            ->bindValue(':input', 'WHERE IsActive=1' . $where)
            ->bindValue(':table', 'StateMst')
            ->bindValue(':orderBy', 'order By StateName asc')
            ->queryAll();

        return ArrayHelper::map($state_data, 'ID', 'StateName');
    }

    public function examConfigList()
    {

        return $data = AdminExamConfigMst::find()->where(['AND', ['!=', 'SessionMonth', ''], ['!=', 'SessionYear', ''], ['=', 'IsActive', 1]])->all();
        // return ArrayHelper::map($data, 'ID', 'SessionMonth','SessionYear');
    }

    public function districtList($stateId = null)
    {
        $where = '';
        if (isset($stateId) && $stateId != '') {
            $where = ' and StateID=' . $stateId;
        }
        $district_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
            ->bindValue(':select', '*')
            ->bindValue(':input', 'WHERE IsActive=1' . $where)
            ->bindValue(':table', 'DistrictMst')
            ->bindValue(':orderBy', 'order By DistrictName asc')
            ->queryAll();
        return ArrayHelper::map($district_data, 'ID', 'DistrictName');
    }

    public function getFormStatusCheck($id, $applicationFormID)
    {
        return Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', '*')
            ->bindValue(':input', "WHERE CandidateID=$id and ApplicationFormID = " . $applicationFormID . " ")
            ->bindValue(':table', 'ApplicationFormStatusTbl')
            ->queryOne();
    }

    public function DisabilityList()
    {
        $Data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
            ->bindValue(':select', '*')
            ->bindValue(':input', 'WHERE IsActive=1')
            ->bindValue(':table', 'DisabilyTypeMst')
            ->bindValue('orderBy', 'order by Name asc')
            ->queryAll();
        return ArrayHelper::map($Data, 'ID', 'Name');
    }

    public function identityData()
    {
        $where = '';
        $Identity_data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', '*')
            ->bindValue(':input', 'WHERE IsActive=1' . $where)
            ->bindValue(':table', 'IdentityMst')
            ->queryAll();
        return ArrayHelper::map($Identity_data, 'ID', 'IdentityName');
    }

    /*****
     * GENERAL/UNRESERVER/GENERAL EWS
     * PWD/THIRD GENDER
     * OBC-NCL/SC/ST
     * PHD DEGREE HOLDER WHOSE MASTERS LEVEL EXAMINATION HAVE BEEN COMPLETED BY 19 SEP -Year-
     *
     * GENERAL/UNRESERVER/GENERAL EWS  PHD DEGREE HOLDER WHOSE MASTERS LEVEL EXAMINATION HAVE BEEN COMPLETED BY 19 SEP -Year-
     * 
     * (CategoryCode)   (CategoryName)
     * GENERAL          GENERAL
     * GENEWS           GENRAL-EWS  
     * OBCNCL           OBS-NCL AS PER CENTRAL LIST  
     * ST               SCHEDULED TRIBES
     * SC               SCHEDULED CASTE
     *****/
    public function checkMinimumPercentageCriteria()
    {
        // $DB = Yii::$app->session->get('NewDB');
        // if (empty($DB)) {
        //     return $this->redirect(['/site/login']);
        // }
        $CandidateID = Yii::$app->user->identity->ID;
        $GenderID = Yii::$app->user->identity->GenderID;
        $Pwd = Yii::$app->user->identity->PhysicalDisability;
        $CastCategoryID = Yii::$app->user->identity->CastCategoryID;
        //PhdOptions == 1
        //PhdMasterLevelTimeDateConfirmation == 1

        $CastCategory = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'CategoryCode,CategoryName')
            ->bindValue(':input', 'WHERE ID=' . $CastCategoryID)
            ->bindValue(':table', 'CasteCategoryMst')
            ->queryOne();
        $CandQualification = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', '*')
            ->bindValue(':input', 'WHERE IsActive=1 and CandidateID=' . $CandidateID)
            ->bindValue(':table', 'CandidateQualificationDetailsTbl')
            ->queryOne();
        $CandGender = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'Gender,GenderCode')
            ->bindValue(':input', 'WHERE ID=' . $GenderID)
            ->bindValue(':table', 'GenderMst')
            ->queryOne();

        $responseArr = [];
        if (isset($CastCategory) && !empty($CastCategory) && isset($CandQualification) && !empty($CandQualification) && isset($CandGender) && !empty($CandGender)) {
            if ($CandQualification['PassStatus'] == 1) {
                $responseArr = [
                    'Gender' => $CandGender['Gender'],
                    'CastCategory' => $CastCategory['CategoryName'],
                    'PhysicalDisability' => (($Pwd == 1) || ($Pwd == 2)) ? 'Yes' : 'No',
                    'PhdDegreeHolder' => (($CandQualification['PhdOptions'] == 1) && ($CandQualification['PhdMasterLevelTimeDateConfirmation'] == 1)) ? 'Yes' : 'No',
                ];
                //1. When candidate has (PWD || Third gender):
                //if (($Pwd == 1) || ($Pwd == 2) || ($CandGender['GenderCode'] == 'THRDGEN')) {
                if (($Pwd == 1) || ($Pwd == 2)) {
                    if ($CandQualification['CgpaPercentageMarks'] < yii::$app->params['PWD_THIRDGENDER_PERCENT']) {
                        //return 'OBC-NCL/SC/ST/PWD/THIRD GENDER';
                        return false;
                    } else {
                        return true;
                    }
                }
                //2. OBC-NCL/SC/ST && PHD DEGREE HOLDER WHOSE MASTERS LEVEL EXAMINATION HAVE BEEN COMPLETED BY 19 SEP:
                if ((($CastCategory['CategoryCode'] == 'OBCNCL') || ($CastCategory['CategoryCode'] == 'ST') || ($CastCategory['CategoryCode'] == 'SC')) && $CandQualification['PhdOptions'] == 1 && $CandQualification['PhdMasterLevelTimeDateConfirmation'] == 1) {
                    if ($CandQualification['CgpaPercentageMarks'] < yii::$app->params['OBCNCL_SC_ST_PhdMasterTimeDateConfirmation_PERCENT']) {
                        //return 'GENERAL/UNRESERVER/GENERAL EWS && PHD DEGREE HOLDER WHOSE MASTERS LEVEL EXAMINATION HAVE BEEN COMPLETED BY 19 SEP';
                        return false;
                    } else {
                        return true;
                    }
                }
                //3. GENERAL/UNRESERVER/GENERAL EWS && PHD DEGREE HOLDER WHOSE MASTERS LEVEL EXAMINATION HAVE BEEN COMPLETED BY 19 SEP:
                if ((($CastCategory['CategoryCode'] == 'GENERAL') || ($CastCategory['CategoryCode'] == 'GENEWS')) && $CandQualification['PhdOptions'] == 1 && $CandQualification['PhdMasterLevelTimeDateConfirmation'] == 1) {
                    if ($CandQualification['CgpaPercentageMarks'] < yii::$app->params['GENERAL_GENERALEWS_PhdMasterTimeDateConfirmation_PERCENT']) {
                        //return 'GENERAL/UNRESERVER/GENERAL EWS && PHD DEGREE HOLDER WHOSE MASTERS LEVEL EXAMINATION HAVE BEEN COMPLETED BY 19 SEP';
                        return false;
                    } else {
                        return true;
                    }
                }
                //When Candidate has (General || General Ews):
                if (($CastCategory['CategoryCode'] == 'GENERAL') || ($CastCategory['CategoryCode'] == 'GENEWS')) {
                    if ($CandQualification['CgpaPercentageMarks'] < yii::$app->params['GENERAL_UNRESERVER_GENERALEWS_PERCENT']) {
                        //return 'GENERAL/UNRESERVER/GENERAL EWS';
                        return false;
                    } else {
                        return true;
                    }
                }
                //When Candidate has (OBC-NCL || ST || ST):
                if (($CastCategory['CategoryCode'] == 'OBCNCL') || ($CastCategory['CategoryCode'] == 'ST') || ($CastCategory['CategoryCode'] == 'SC')) {
                    if ($CandQualification['CgpaPercentageMarks'] < yii::$app->params['OBCNCL_SC_ST_PERCENT']) {
                        //return 'OBC-NCL/SC/ST/PWD/THIRD GENDER';
                        return false;
                    } else {
                        return true;
                    }
                }
            } else {
                return true;
            }
        }
        return false;
    }

    public function checkAgeCriteria()
    {
       

        $CandidateID = Yii::$app->user->identity->ID;
        $GenderID = Yii::$app->user->identity->GenderID;
        $Pwd = Yii::$app->user->identity->PhysicalDisability;
        $CastCategoryID = Yii::$app->user->identity->CastCategoryID;
        $CandidateDOB = Yii::$app->user->identity->DOB;

        $applicationStatus = Yii::$app->ApplicationOpen->Openwindow();
        $correctionStatus = Yii::$app->CorrectionWindow->Openwindow();

        if (isset($applicationStatus, $correctionStatus) && ($applicationStatus == 0) && ($correctionStatus == 1)) {

            $CandidateCorrectionDataByCol = Yii::$app->masterdata->getCorrectionDataByCol('PersonalDetails');

            if(isset($CandidateCorrectionDataByCol) && !empty($CandidateCorrectionDataByCol)){
                $GenderID = $CandidateCorrectionDataByCol['GenderID'];
                $Pwd = $CandidateCorrectionDataByCol['PhysicalDisability'];
                $CastCategoryID = $CandidateCorrectionDataByCol['CastCategoryID'];
                $CandidateDOB = $CandidateCorrectionDataByCol['DOB'];
            }

        }



        $CandCastCategoryData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'CategoryCode')
            ->bindValue(':input', 'WHERE ID=' . $CastCategoryID)
            ->bindValue(':table', 'CasteCategoryMst')
            ->queryOne();
        $CandApplyCourse = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'ApplycourseID')
            ->bindValue(':input', 'WHERE IsActive=1 and CandidateID=' . $CandidateID)
            ->bindValue(':table', 'CandidateApplyCourseTbl')
            ->queryOne();
        $CandApplyCourseData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'CourseCode')
            ->bindValue(':input', 'WHERE IsActive=1 and ID=' . $CandApplyCourse['ApplycourseID'])
            ->bindValue(':table', 'CourseMst')
            ->queryOne();
        $CandGenderData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'GenderCode')
            ->bindValue(':input', 'WHERE ID=' . $GenderID)
            ->bindValue(':table', 'GenderMst')
            ->queryOne();

        if (isset($CandCastCategoryData) && !empty($CandCastCategoryData) && isset($CandGenderData) && !empty($CandGenderData) && isset($CandApplyCourseData) && !empty($CandApplyCourseData) && isset($CandApplyCourse) && !empty($CandApplyCourse)) {
            if ($CandApplyCourseData['CourseCode'] == 'C001') {

                $cand_cast_category = $CandCastCategoryData['CategoryCode'];
                $cand_gender = $CandGenderData['GenderCode'];
                $cand_is_pwd = (($Pwd == 1) || ($Pwd == 2)) ? 'yes' : 'no';

                // $cand_dob = date('Y-m-d', strtotime(Yii::$app->user->identity->DOB));
                $cand_dob = date('Y-m-d', strtotime($CandidateDOB));

                $max_age_as_on_time_of_registration_date = date('Y-m-d', strtotime(yii::$app->params['MAX_AGE_AS_ON_TIME_OF_REGISTRATION_DATE']));
                $cand_age_calculated_as_on_date = $this->ageCalculatorAsOnGivendate($cand_dob, $max_age_as_on_time_of_registration_date);
                //print_r($cand_age_calculated_as_on_date);die;
                $general_generalEws_maxAgeVal =  yii::$app->params['general_generalEws_maxAgeVal']; //24;
                $obcNcl_maxAgeVal =  yii::$app->params['obcNcl_maxAgeVal']; //24;
                $sc_st_thirdGender_pwd_female_maxAgeVal =  yii::$app->params['sc_st_thirdGender_pwd_female_maxAgeVal']; //29;
                //Age criteria condition check:
                //11111111
                //if(($cand_gender == 'F') || ($cand_gender == 'THRDGEN') || ($cand_is_pwd == 'yes')){
                if (($cand_is_pwd == 'yes')) {
                    if ($this->checkAgeAsOnDate($cand_age_calculated_as_on_date, $sc_st_thirdGender_pwd_female_maxAgeVal)) {
                        //return 'sc_st_thirdGender_pwd_female_maxAgeVal<=29';
                        return true;
                    } else {
                        //return 'sc_st_thirdGender_pwd_female_maxAgeVal>29';
                        return false;
                    }
                }
                //2222222
                if (($cand_cast_category == 'SC') || ($cand_cast_category == 'ST')) {
                    if ($this->checkAgeAsOnDate($cand_age_calculated_as_on_date, $sc_st_thirdGender_pwd_female_maxAgeVal)) {
                        //return 'sc_st_thirdGender_pwd_female_maxAgeVal<=29';
                        return true;
                    } else {
                        //return 'sc_st_thirdGender_pwd_female_maxAgeVal>29';
                        return false;
                    }
                }
                //33333333
                if (($cand_cast_category == 'GENERAL') || ($cand_cast_category == 'GENEWS')) {
                    if ($this->checkAgeAsOnDate($cand_age_calculated_as_on_date, $general_generalEws_maxAgeVal)) {
                        //return 'general_generalEws_maxAgeVal<=24';
                        return true;
                    } else {
                        //return 'general_generalEws_maxAgeVal>24';
                        return false;
                    }
                }
                //444444444
                if ($cand_cast_category == 'OBCNCL') {
                    if ($this->checkAgeAsOnDate($cand_age_calculated_as_on_date, $obcNcl_maxAgeVal)) {
                        //return 'obcNcl_maxAgeVal<=24';
                        return true;
                    } else {
                        //return 'obcNcl_maxAgeVal>24';
                        return false;
                    }
                }
                return false;
            } else {
                return true;
            }
        }
        return false;
    }


    /*
     * @$cand_age_calculated_as_on_date = array() , Candidate age array key as (Years, months and days)
     * @$exp = Candidate experience in (Ex-Serviceman and Armed force)
     * @calculating here by (max_age_criteria(30) + @$exp)
    */
    public function checkAgeRelaxation($cand_age_calculated_as_on_date, $max_age_as_on_date, $exp = 0)
    {
        //Compare Age:
        if (($cand_age_calculated_as_on_date != null) && ($exp > 0)) {
            $max_age_with_exp = $max_age_as_on_date + $exp;
            $age_year = $cand_age_calculated_as_on_date['ageYear'];
            $age_month = $cand_age_calculated_as_on_date['ageMonth'];
            $age_days = $cand_age_calculated_as_on_date['ageDays'];
            if ($age_year > $max_age_with_exp) {
                return false;
            }
            if ($age_year < $max_age_with_exp) {
                return true;
            }
            if ($age_year == $max_age_with_exp) {
                if (($age_month > 0) || ($age_days > 0)) {
                    return false;
                }
                return true;
            }
            return false;
        }
    }

    public function checkAgeAsOnDate($cand_age_calculated_as_on_date, $MAX_AGE_AS_ON_DATE, $exp = 0)
    {
        //Compare Age:
        if (($cand_age_calculated_as_on_date != null) && ($MAX_AGE_AS_ON_DATE != null)) {
            $age_year = $cand_age_calculated_as_on_date['ageYear'];
            //if($exp > 0){
            //    $age_year = $cand_age_calculated_as_on_date['ageYear'] + $exp;
            //}
            $age_month = $cand_age_calculated_as_on_date['ageMonth'];
            $age_days = $cand_age_calculated_as_on_date['ageDays'];
            if ($age_year > $MAX_AGE_AS_ON_DATE) {
                return false;
            }
            if ($age_year < $MAX_AGE_AS_ON_DATE) {
                return true;
            }
            if ($age_year == $MAX_AGE_AS_ON_DATE) {
                if (($age_month > 0) || ($age_days > 0)) {
                    return false;
                }
                return true;
            }
            return false;
        }
    }

    //function ageCalculator($dob, $max_age_as_on_time_date = '')
    //{
    //    if ($max_age_as_on_time_date == '') {
    //        $today   = new DateTime('today');
    //    } else {
    //        $today   = new DateTime($max_age_as_on_time_date);
    //    }
    //    if (!empty($dob)) {
    //        $birthdate = new DateTime($dob);
    //        $age = $birthdate->diff($today)->y;
    //        return $age;
    //    } else {
    //        return 0;
    //    }
    //}

    function ageCalculatorAsOnGivendate($dob, $max_age_as_on_time_date)
    {
        if (!empty($dob)) {
            //$max_age_as_on_time_date = date('Y-m-d', strtotime($max_age_as_on_time_date));
            $birthdate = new DateTime($dob);
            $asOnGivendate   = new DateTime($max_age_as_on_time_date);
            $ageYear = $birthdate->diff($asOnGivendate)->y;
            $ageMonth = $birthdate->diff($asOnGivendate)->m;
            $ageDays = $birthdate->diff($asOnGivendate)->d;
            $result = [
                'ageYear' => $ageYear,
                'ageMonth' => $ageMonth,
                'ageDays' => $ageDays,
            ];
            return $result;
        } else {
            return 0;
        }
    }
    public function getExamFeeByCandidateCastCategory()
    {
		return 1;
        $CandidateID = Yii::$app->user->identity->ID;
        $CastCategoryID = Yii::$app->user->identity->CastCategoryID;
        $Pwd = Yii::$app->user->identity->PhysicalDisability;
        $GenderID = Yii::$app->user->identity->GenderID;
        $CandCastCategoryData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', '*')
            ->bindValue(':input', "WHERE ID=$CastCategoryID")
            ->bindValue(':table', 'CasteCategoryMst')
            ->queryOne();
        $CandGenderData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'GenderCode')
            ->bindValue(':input', "WHERE ID=$GenderID")
            ->bindValue(':table', 'GenderMst')
            ->queryOne();

        if (isset($CandCastCategoryData) && !empty($CandCastCategoryData) && isset($CandGenderData) && !empty($CandGenderData)) {
            $cand_is_pwd = (($Pwd == 1) || ($Pwd == 2)) ? 'yes' : 'no';
            $cand_cast_category = $CandCastCategoryData['CategoryCode'];
            $cand_gender = $CandGenderData['GenderCode'];

            //Exam Fee by Cas Category Params:
            $ExamFee_General = yii::$app->params['ExamFee_General'];
            $ExamFee_GeneralEws_ObcNcl = yii::$app->params['ExamFee_GeneralEws_ObcNcl'];
            $ExamFee_Sc_St = yii::$app->params['ExamFee_Sc_St'];
            $ExamFee_ThirdGender = yii::$app->params['ExamFee_ThirdGender'];
            $ExamFee_Pwd = yii::$app->params['ExamFee_Pwd'];


            $ExamFee_BDES_ST_SC_PWD = yii::$app->params['ExamFee_BDES_ST_SC_PWD'];
            $ExamFee_BDES_Gen_OBC_EWS = yii::$app->params['ExamFee_BDES_Gen_OBC_EWS'];

            $ApplySubject = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
                ->bindValue(':select', 'SubjecSpecializationMstID')
                ->bindValue(':input', "WHERE IsActive=1 AND CandidateID=$CandidateID")
                ->bindValue(':orderBy', 'order by SubjecSpecializationMstID asc')
                ->bindValue(':table', 'CandidateApplySubjectTbl')
                ->queryOne();
            if (isset($ApplySubject['SubjecSpecializationMstID']) && !empty($ApplySubject['SubjecSpecializationMstID']) && $ApplySubject['SubjecSpecializationMstID'] == 10061) {
                if ($cand_is_pwd == 'yes') {
                    //return '11111';
                    return number_format($ExamFee_BDES_ST_SC_PWD, 2, '.', '');
                } else if ($cand_cast_category == 'GENERAL') {
                    //return '33333333333333';
                    return number_format($ExamFee_BDES_Gen_OBC_EWS, 2, '.', '');
                } else if (($cand_cast_category == 'GENEWS') || ($cand_cast_category == 'OBCNCL')) {
                    //return '44444444444';
                    return number_format($ExamFee_BDES_Gen_OBC_EWS, 2, '.', '');
                } else if (($cand_cast_category == 'SC') || ($cand_cast_category == 'ST')) {
                    //return '55555555';
                    return number_format($ExamFee_BDES_ST_SC_PWD, 2, '.', '');
                }
            } else {
                if ($cand_is_pwd == 'yes') {
                    //return '11111';
                    return number_format($ExamFee_Pwd, 2, '.', '');
                } else if ($cand_cast_category == 'GENERAL') {
                    //return '33333333333333';
                    return number_format($ExamFee_General, 2, '.', '');
                } else if (($cand_cast_category == 'GENEWS') || ($cand_cast_category == 'OBCNCL')) {
                    //return '44444444444';
                    return number_format($ExamFee_GeneralEws_ObcNcl, 2, '.', '');
                } else if (($cand_cast_category == 'SC') || ($cand_cast_category == 'ST')) {
                    //return '55555555';
                    return number_format($ExamFee_Sc_St, 2, '.', '');
                }
            }
            return false;
        }
        return false;
    }
    /***** Old code
    public function getExamFeeByCandidateCastCategory()
    {
//        $DB = Yii::$app->session->get('NewDB');
//        if (empty($DB)) {
//            return $this->redirect(['/site/login']);
//        }
        $CandidateID = Yii::$app->user->identity->ID;
        $CastCategoryID = Yii::$app->user->identity->CastCategoryID;
        $Pwd = Yii::$app->user->identity->PhysicalDisability;
        $GenderID = Yii::$app->user->identity->GenderID;
        $CandCastCategoryData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', '*')
            ->bindValue(':input', 'WHERE ID=' . $CastCategoryID)
            ->bindValue(':table', 'CasteCategoryMst')
            ->queryOne();
        $CandGenderData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', '*')
            ->bindValue(':input', 'WHERE ID=' . $GenderID)
            ->bindValue(':table', 'GenderMst')
            ->queryOne();
        $CandApplyCourseData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'ApplycourseID')
            ->bindValue(':input', 'WHERE IsActive=1 and CandidateID=' . $CandidateID)
            ->bindValue(':table', 'CandidateApplyCourseTbl')
            ->queryOne();

        if (isset($CandCastCategoryData) && !empty($CandCastCategoryData) && isset($CandGenderData) && !empty($CandGenderData) && isset($CandApplyCourseData) && !empty($CandApplyCourseData)) {
            //$cand_cast_category = $CandCastCategoryData['CategoryCode'];
            //$cand_gender = $CandGenderData['GenderCode'];
            $cand_is_pwd = (($Pwd == 1) || ($Pwd == 2)) ? 'yes' : 'no';
            $cand_course_id = $CandApplyCourseData['ApplycourseID'];

            if ($cand_is_pwd == 'yes') {
                $getFeeData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
                    ->bindValue(':select', 'ID,Amount')
                    ->bindValue(':input', 'WHERE IsActive=1 and CourseID=' . $cand_course_id . ' and CategoryID=' . $CastCategoryID . ' and GenderID=' . $GenderID . ' and QuotaCategoryID=' . Yii::$app->params['QuotaCategoryID'])
                    ->bindValue(':table', 'FeeMst')
                    ->queryOne();
                return number_format($getFeeData['Amount'], 2, '.', '');
            }
            if ($cand_is_pwd == 'no') {
                $getFeeData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
                    ->bindValue(':select', 'ID,Amount')
                    ->bindValue(':input', 'WHERE IsActive=1 and CourseID=' . $cand_course_id . ' and CategoryID=' . $CastCategoryID . ' and GenderID=' . $GenderID . ' and QuotaCategoryID is null')
                    ->bindValue(':table', 'FeeMst')
                    ->queryOne();
                return number_format($getFeeData['Amount'], 2, '.', '');
            }
            return false;

            //General / Unreserved
            //            if($cand_cast_category == 'GENERAL'){
            //                return  yii::$app->params['General_Unreserved'];
            //            }
            //Gen - EWS * / OBC - NCL **
            //            if(($cand_cast_category == 'GENEWS') || ($cand_cast_category == 'OBCNCL')){
            //                return yii::$app->params['GenEWS_OBCNCL'];
            //            }
            //Scheduled Caste ( SC ) / Scheduled Tribes ( ST ) / Person with / Disability ( PwD ) / Third Gender
            //            if(($cand_cast_category == 'SC') || ($cand_cast_category == 'ST') || (($Pwd == 1) || ($Pwd == 2)) || ($cand_gender == 'THRDGEN')){
            //                return  yii::$app->params['SC_ST_PWD_ThirdGender'];
            //            }
        }
        return false;
    }
    Old code end *****/
    public function getCastCategoryIdByCategoryCode(string $CategoryCode)
    {
        //        $DB = Yii::$app->session->get('NewDB');
        //        if (empty($DB)) {
        //            return $this->redirect(['/site/login']);
        //        }
        $CandCastCategoryData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'ID,CategoryCode')
            ->bindValue(':input', "WHERE CategoryCode='$CategoryCode'")
            ->bindValue(':table', 'CasteCategoryMst')
            ->queryOne();
        return $CandCastCategoryData['ID'];
    }
    public function getGenderIdByGenderCode(string $GenderCode)
    {
        //        $DB = Yii::$app->session->get('NewDB');
        //        if (empty($DB)) {
        //            return $this->redirect(['/site/login']);
        //        }
        $CandGenderData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'ID,GenderCode')
            ->bindValue(':input', "WHERE GenderCode='$GenderCode'")
            ->bindValue(':table', 'GenderMst')
            ->queryOne();
        return $CandGenderData['ID'];
    }

    public function getChoiceStateCity($state_id = '', $selected_city_id = '')
    {
        //        $DB = Yii::$app->session->get('NewDB');
        //        if (empty($DB)) {
        //            return $this->redirect(['/site/login']);
        //        }
        $data = [];
        if ($state_id == null) {
            return $data;
        }
        $StateCityData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
            ->bindValue(':select', 'ID,CityName')
            ->bindValue(':input', "WHERE IsActive=1 and StateID=$state_id")
            ->bindValue(':table', 'CityMst')
            ->bindValue('orderBy', 'order by CityName asc')
            ->queryAll();
        if (isset($StateCityData) && !empty($StateCityData)) {
            $data =  ArrayHelper::map($StateCityData, 'ID', 'CityName');
        }
        return $data;
    }

    public function getChoiceStateCityCampus($Campusid)
    {
        //        $DB = Yii::$app->session->get('NewDB');
        //        if (empty($DB)) {
        //            return $this->redirect(['/site/login']);
        //        }
        $data = [];
        if ($Campusid == null) {
            return $data;
        }
        $StateCityData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
            ->bindValue(':select', 'ID,CityName')
            ->bindValue(':input', "WHERE IsActive=1 and IsCampus=$Campusid")
            ->bindValue(':table', 'CityMst')
            ->bindValue('orderBy', 'order by CityName asc')
            ->queryAll();
        if (isset($StateCityData) && !empty($StateCityData)) {
            $data =  ArrayHelper::map($StateCityData, 'ID', 'CityName');
        }
        return $data;
    }
    public function checkVerifymobile($ID)
    {
        //        $DB = Yii::$app->session->get('NewDB');
        //        if (empty($DB)) {
        //            return $this->redirect(['/site/login']);
        //        }
        if (isset($ID) && $ID != null) {
            $verifyOtpCheck = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
                ->bindValue(':select', '*')
                ->bindValue(':input', 'WHERE CandidateID=' . $ID)
                ->bindValue(':table', 'CandidateOtpTbl')
                ->queryOne();
        }
        return $verifyOtpCheck;
    }
    public function logFileGenrate($request, $response, $clientIP)
    {

        if (isset($request, $response) && !empty($request) && !empty($response)) {
            date_default_timezone_set('Asia/Kolkata');
            $dateTime = array('dateTime' => date("d-m-Y H:i:s"), 'clientIP' => $clientIP);
            $finalArray = array_merge($request, $response, $dateTime);
            $filedata = array();
            $date = date('d-m-Y');
            $foldername = 'otpLog';
            $path   = Yii::getAlias('@frontendweb') . '/uploads/' . trim($foldername) . "/";
            FileHelper::createDirectory($path, $mode = 0775, $recursive = true);
            $fileName = $date . ".json";
            $filePath = $path . $fileName;
            if (file_exists($filePath)) {
                $jsonFile = file_get_contents($filePath) or die("Unable to open file!");
                $jsonToArray = json_decode($jsonFile, true);
                if (isset($jsonToArray) && !empty($jsonToArray) && is_array($jsonToArray)) {
                    array_push($jsonToArray, $finalArray);
                    $jsonData = json_encode($jsonToArray);
                    file_put_contents($filePath, $jsonData);
                }
            } else {
                $myfile = fopen($filePath, "w") or die("Unable to open file!");
                array_push($filedata, $finalArray);
                $jsonData = json_encode($filedata);
                fwrite($myfile, $jsonData);
                fclose($myfile);
            }
        }
    }
    public function getPaymentGateway(string $GetwayID)
    {
        //         $DB = Yii::$app->session->get('NewDB');
        //        if (empty($DB)) {
        //            return $this->redirect(['/site/login']);
        //        }
        $CandCastCategoryData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'GatewayName')
            ->bindValue(':input', "WHERE ID=$GetwayID")
            ->bindValue(':table', 'PaymentGatewayMst')
            ->queryOne();
        return $CandCastCategoryData['GatewayName'];
    }

    public function finalSubmitSendmailWithattach($candidateID)
    {
        // echo $candidateID; die();
        $result = \Yii::$app->db->createCommand("exec  getReviewData :candidate_id")
            ->bindValue(':candidate_id', $candidateID)
            ->queryOne();
        $examcdataresult = \Yii::$app->db->createCommand("exec  getReviewExamcenterData :candidate_id")
            ->bindValue(':candidate_id', $candidateID)
            ->queryAll();

        $examcdataresultCampus = \Yii::$app->db->createCommand("exec  getReviewExamcenterDataCampus :candidate_id")
            ->bindValue(':candidate_id', $candidateID)
            ->queryAll();

        $ParentOcupdataresult = \Yii::$app->db->createCommand("exec  getReviewExamcenterparnOcupData :candidate_id")
            ->bindValue(':candidate_id', $candidateID)
            ->queryAll();
        $ParentQualifdataresult = \Yii::$app->db->createCommand("exec  getReviewExamcenterparnQualifData :candidate_id")
            ->bindValue(':candidate_id', $candidateID)
            ->queryAll();
        /* File upload */
        $candidateUploadDocument = \Yii::$app->db->createCommand("exec  SpCandidateUplodedDoc :candidate_id")
            ->bindValue(':candidate_id', $candidateID)
            ->queryAll();
       
            // $GetTransactionData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table,:orderBy")
            // ->bindValue(':select', 'CandidateID,InvoiceCode,TranscationID,ActualExamFee,PaidAmount,PaymentGatewayID,PaymentSubmitDate,PaymentSucessDate,PaymentStatus')
            // ->bindValue(':input', "WHERE CandidateID='$candidateID' AND ResponseCode='00'")
            // ->bindValue(':table', 'PaymentTranscationTbl')
            // ->bindValue(':orderBy', 'order by PaymentSucessDate desc')
            // ->queryOne();

        $GetTransactionData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table,:orderBy")
			->bindValue(':select', 'PaymentTranscationTbl.CandidateID,PaymentTranscationTbl.InvoiceCode,PaymentTranscationTbl.TranscationID,PaymentTranscationTbl.ActualExamFee,PaymentTranscationTbl.PaidAmount,PaymentTranscationTbl.PaymentGatewayID,PaymentTranscationTbl.PaymentSubmitDate,PaymentTranscationTbl.PaymentSucessDate,PaymentTranscationTbl.PaymentStatus,PaymentGatewayMst.GatewayName')
			->bindValue(':input', "left join PaymentGatewayMst on PaymentGatewayMst.ID = PaymentTranscationTbl.PaymentGatewayID WHERE CandidateID='$candidateID' AND (ResponseCode='00' OR ResponseCode='Success' OR ResponseCode='0300') ")
			->bindValue(':table', 'PaymentTranscationTbl')
			->bindValue(':orderBy', 'order by PaymentSucessDate desc')
			->queryOne();

        $twelveDocument = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'PassStatus12')
            ->bindValue(':input', 'WHERE IsActive=1 and CandidateID='.$candidateID)
            ->bindValue(':table', 'CandidateQualificationDetailsTblFinal')->queryOne();

        $fieldValidationRule = $this->getAllDocumentValidation();
        $finalArray = array();
        foreach ($fieldValidationRule as $data) {
            $documentName = strtolower(trim($data['DocumentName']));
            if (isset($data['IsRequired']) && $data['IsRequired'] == 1) {
                array_push($finalArray, $data);
            }
            if (isset($data['IsRequired']) && isset($data['DocumentName']) && isset($result['CastCategoryID']) && $data['IsRequired'] == 0 && ($result['CastCategoryID'] != 1) &&  preg_match("/category/i", strtolower($documentName))) {
                array_push($finalArray, $data);
            }
            if (isset($data['IsRequired']) && isset($data['DocumentName']) && isset($result['PhysicalDisability']) && $data['IsRequired'] == 0 && ($result['PhysicalDisability'] == 1) &&  preg_match("/pwd/i", strtolower($documentName))) {
                array_push($finalArray, $data);
            }
            if (isset($data['IsRequired']) && isset($data['DocumentName']) && isset($result['NeedScribe']) && $data['IsRequired'] == 0 && ($result['PhysicalDisability'] == 1 && $result['NeedScribe'] == 2) &&  preg_match("/scribe/i", strtolower($documentName))) {
                array_push($finalArray, $data);
            }
            if (isset($data['IsRequired']) && isset($data['DocumentName']) && isset($result['SubjecSpecializationMstID']) && $data['IsRequired'] == 0 && ($result['SubjecSpecializationMstID'] == 10074) &&  preg_match("/Artisan/i", strtolower($documentName))) {
                array_push($finalArray, $data);
            }

        }
        if (isset($finalArray) && isset($candidateUploadDocument) &&  !empty($finalArray) && !empty($candidateUploadDocument)) {
            $visiviltyCount = 0;
            foreach ($finalArray as $k1 => $v1) {
                foreach ($candidateUploadDocument as $k2 => $v2) {
                    if (isset($v1) && isset($v2['DocumentID']) && !empty($v1['ID']) && !empty($v2['DocumentID']) && $v1['ID'] == $v2['DocumentID']) {
                        $finalArray[$k1]['UploadDocument'] = $v2['UploadDocument'];
                        $visiviltyCount++;
                    }
                }
            }
        }
        $content = Yii::$app->controller->renderPartial('//layouts/emailreviewpdf', [
            'model' => $result,
            'examcdata' => $examcdataresult,
            'examcdataresultCampus' => $examcdataresultCampus,
            'examParentOcup' => $ParentOcupdataresult,
            'parentQulificat' => $ParentQualifdataresult,
            'documentUpload' => $finalArray,
            'GetTransactionData' => $GetTransactionData,
            // 'IsPwd'=>((Yii::$app->user->identity->PhysicalDisability == 1) || (Yii::$app->user->identity->PhysicalDisability == 2)) ? 'yes' : 'no',
        ]);
        $mpdf = new mPDF();
        $mpdf->WriteHTML($content);
        $mpdf->showImageErrors = true;
        //$fileName = $ApplicationNumber.'_'.time().'.pdf';
        //$mpdf->Output($fileName, 'D');
        //$mpdf->Output();
        $candidateMasterData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'ID,ApplicationNumber,CandidateName,CandidateEmail,CandidateMobile')
            ->bindValue(':input', "WHERE ID='$candidateID'")
            ->bindValue(':table', 'CandidateTbl')
            ->queryOne();
        $CandidateName = (isset($candidateMasterData['CandidateName']) && !empty($candidateMasterData['CandidateName'])) ? $candidateMasterData['CandidateName'] : Yii::$app->user->identity->CandidateName;
        $ApplicationNumber = (isset($candidateMasterData['ApplicationNumber']) && !empty($candidateMasterData['ApplicationNumber'])) ? $candidateMasterData['ApplicationNumber'] : Yii::$app->user->identity->ApplicationNumber;
        $CandidateEmail = (isset($candidateMasterData['CandidateEmail']) && !empty($candidateMasterData['CandidateEmail'])) ? $candidateMasterData['CandidateEmail'] : Yii::$app->user->identity->CandidateEmail;
        $CandidateMobile = (isset($candidateMasterData['CandidateMobile']) && !empty($candidateMasterData['CandidateMobile'])) ? $candidateMasterData['CandidateMobile'] : Yii::$app->user->identity->CandidateMobile;
        /*Send SMS Application submitted on Mobile Number */
        
        
        $ApplicationName = yii::$app->params['Session'];
        $UGCNET = Yii::$app->params['UGCNET'];
        $message = "Dear Candidate, Your application form for $UGCNET has been submitted successfully, Your application number is $ApplicationNumber NTA";
        $mobileno = trim($CandidateMobile);
        $temp =  yii::$app->params['OTPSMSTemplate'];
        $data =  Yii::$app->SmsComponent->SMSSend($mobileno, $message, $temp, true);


        //For sending mail switch case:
        $mailResponse = 0;
        $EmailServiceProviderName = '';
        if(isset(Yii::$app->params['IsSmtpMailEnable']) && (Yii::$app->params['IsSmtpMailEnable'] === true)){
            //SMTP mail Active:
            // $variables = array(
            //     "{{CandidateName}}" => ucwords($CandidateName),
            //     "{{JEEMAIN}}" => $ApplicationName,
            //     "{{EMAIL_SIGN}}" => Yii::$app->params['EMAIL_SIGN'],

            // );
            // $attachment = ['attachment' => $mpdf->Output('', 'S')];
            // $emailSendStatus = Yii::$app->mailing->sendMailContent('Application Completed', $variables, trim($CandidateEmail), $attachment, $ApplicationNumber);
            // if (isset($emailSendStatus) && $emailSendStatus == 1) {
            //     $mailResponse = 1;
            //     $EmailServiceProviderName = 'Smtp Email';
            // }
        } else if (isset(Yii::$app->params['IsSmtpMailEnable']) && (Yii::$app->params['IsSmtpMailEnable'] === false)){

            $message = "Dear Candidate, Your application form for $UGCNET has been submitted successfully, Your application number is $ApplicationNumber NTA";
            $mobileno = trim($CandidateMobile);
            $temp = Yii::$app->params['dltContentId'];
            Yii::$app->SmsComponent->NewSmsAPIGet($mobileno, $message, $temp, true);

            //Mail template Active:
            $To = $CandidateEmail;
            $MailTemplateArr = Yii::$app->params['MailTemplateArr'];
            $TEMPLATE_UID = $MailTemplateArr['ApplicationComplete'];
            // $DOCUMENT = $filePathDomain;
            $DOCUMENT = $content;
            // $PARAMS = array('CNAME' =>'Candidate', 'EXAMUNIT' => Yii::$app->params['EMAIL_SIGN']);
            $PARAMS = array('CANDIDATENAME' => ucfirst($CandidateName), 'PROJECTNAME' => Yii::$app->params['EMAIL_SIGN']);
            if(isset($To,$TEMPLATE_UID) && !empty($To) && !empty($TEMPLATE_UID)){
                $templateMailResponse = Yii::$app->sentcommonmail->sentmail($To,$TEMPLATE_UID,$PARAMS,$DOCUMENT);
                if(isset($templateMailResponse,$templateMailResponse->status,$templateMailResponse->message) && !empty($templateMailResponse) && ($templateMailResponse->status == 1) && (strtolower($templateMailResponse->message) == 'success')){
                    $mailResponse = 1;
                    $EmailServiceProviderName = 'New Email Template';
                }
            }
        }

        if (isset($mailResponse) && ($mailResponse == 1)) {
            $moduleName = 'Confirmation Email';
            $activityName = 'Confirmation Email After Payment Success';
            $data = array("moduleName" => $moduleName, "activityName" => $activityName, "ApplicationNumber" => $ApplicationNumber, "CandidateID" => $candidateID);
    
            Yii::$app->emailactivitylog->EmailLog(['activityName' => 'Confirmation Email', 'activityDescription' => 'Confirmation Email After Payment Success', 'CandidateID' => $candidateID, 'ApplicationNumber' => $ApplicationNumber, 'CandidateEmail' => $CandidateEmail, 'IsApplication' => Yii::$app->ApplicationOpen->Openwindow(), 'IsCorrection' => Yii::$app->CorrectionWindow->Openwindow(), "url" => Yii::$app->request->referrer, 'EmailServiceProviderName' => $EmailServiceProviderName]);
            return ['mailResponse' => $mailResponse, 'EmailServiceProviderName' => $EmailServiceProviderName];
        } else {
            Yii::$app->session->setFlash('error', 'Email not sent.');
            return $this->redirect(['../dashboard/index']);
        }



        //$otpResponse = $data['response'];
        //$otpRequest = $data['request']; 
        /*Send SMS Application submitted on Mobile Number*/
        // $variables = array(
        //     "{{CandidateName}}" => ucwords($CandidateName),
        //     "{{UGCNET}}" => Yii::$app->params['UGCNET']
        // );
        // $attachment = ['attachment' => $mpdf->Output('', 'S')];

        // $EmailSendedStatus = Yii::$app->mailing->sendMailContent('Application Completed', $variables, trim($CandidateEmail), $attachment, $ApplicationNumber);
        // return $EmailSendedStatus;

        // //For sending mail switch case:
        // $mailResponse = 0;
        // $EmailServiceProviderName = '';

        // if(isset(Yii::$app->params['EnableSMTPemail']) && (Yii::$app->params['EnableSMTPemail'] === true)){
        //     $EmailSendedStatus = Yii::$app->mailing->sendMailContent('Application Completed', $variables, trim($CandidateEmail), $attachment, $ApplicationNumber);
        //     // return $EmailSendedStatus;
        //     if (isset($EmailSendedStatus) && $EmailSendedStatus == 1) {
        //         $mailResponse = 1;
        //         $EmailServiceProviderName = 'Smtp Email';
        //     }
        // } else {
        //     //Mail template Active:
        //     $To = $CandidateEmail;
        //     $MailTemplateArr = Yii::$app->params['MailTemplateArr'];
        //     $TEMPLATE_UID = $MailTemplateArr['ApplicationComplete'];
        //     // $DOCUMENT = $filePathDomain;
        //     $DOCUMENT = $attachment;
            
        //     //$PARAMS = array('CANDIDATENAME' => ucfirst($CandidateName), 'PROJECTNAME' => Yii::$app->params['EMAIL_SIGN'].'<b><br> National Testing Agency</b>');
        //     $PARAMS = array('CNAME' =>'Candidate', 'EXAMUNIT' => Yii::$app->params['EMAIL_SIGN']);
        //     if(isset($To,$TEMPLATE_UID) && !empty($To) && !empty($TEMPLATE_UID)){
        //         $templateMailResponse = Yii::$app->sentcommonmail->sentmail($To,$TEMPLATE_UID,$PARAMS,$DOCUMENT);
        //         if(isset($templateMailResponse,$templateMailResponse->status,$templateMailResponse->message) && !empty($templateMailResponse) && ($templateMailResponse->status == 1) && (strtolower($templateMailResponse->message) == 'success')){
        //             $mailResponse = 1;
        //             // $EmailServiceProviderName = 'New Email Template';
        //             // return $templateMailResponse;
        //         }
        //     }
        // }

        // if (isset($mailResponse) && ($mailResponse == 1)) {
        //     $moduleName = 'Confirmation Email';
        //     $activityName = 'Confirmation Email After Payment Success';
        //     $data = array("moduleName" => $moduleName, "activityName" => $activityName, "ApplicationNumber" => $ApplicationNumber, "CandidateID" => $candidateID);
    
        //     Yii::$app->emailactivitylog->EmailLog(['activityName' => 'Confirmation Email', 'activityDescription' => 'Confirmation Email After Payment Success', 'CandidateID' => $candidateID, 'ApplicationNumber' => $ApplicationNumber, 'CandidateEmail' => $CandidateEmail, 'IsApplication' => Yii::$app->ApplicationOpen->Openwindow(), 'IsCorrection' => Yii::$app->CorrectionWindow->Openwindow(), "url" => Yii::$app->request->referrer, 'EmailServiceProviderName' => $EmailServiceProviderName]);
        //     return ['mailResponse' => $mailResponse, 'EmailServiceProviderName' => $EmailServiceProviderName];
        // } else {
        //     Yii::$app->session->setFlash('error', 'Email not sent.');
        //     return $this->redirect(['../dashboard/index']);
        // }

        //return $mailResponse;


    }


    public function getAllDocumentValidation()
    {
        //        $DB = Yii::$app->session->get('NewDB');
        //        if (empty($DB)) {
        //            return $this->redirect(['/site/login']);
        //        }
        $validationArray = array();
        $allDocumentArray = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', '*')
            ->bindValue(':input', "WHERE IsActive=1 order by ID asc")
            ->bindValue(':table', 'DocumentMst')->queryAll();
        if (isset($allDocumentArray) && !empty($allDocumentArray)) {
            return $allDocumentArray;
        }
        return $validationArray;
    }

    public function checkPercentageValidation($marksPercentage = '', $isJrfOpt = '', $castCategoryCode = '', $genderCode = '', $IsPwd = '', $graduatePassStatus = '', $pgPassStatus = '', $IsPgCourseMSPhD = '')
    {
        if ($isJrfOpt == '' && $genderCode == '' && $graduatePassStatus == '' && $pgPassStatus == '' && $IsPgCourseMSPhD) {
            return 'Please pass at least one params';
        }
        $returnCheck = 0;
        //For JRF:
        if ($isJrfOpt == 'yes') {
            if (($pgPassStatus == 3) && (($graduatePassStatus == 1) || ($graduatePassStatus == 2))) {
                //OBC-NCL / SC / ST / PwD / Third gender	50%
                // if(($castCategoryCode == 'OBCNCL') || ($castCategoryCode == 'ST') || ($castCategoryCode == 'SC') || ($IsPwd == 'yes') || ($genderCode == 'THRDGEN')){
                if (($castCategoryCode == 'OBCNCL') || ($castCategoryCode == 'ST') || ($castCategoryCode == 'SC') || ($IsPwd == 'yes')) {
                    if (($marksPercentage['graduate_marks'] != '') && ($marksPercentage['graduate_marks'] < 50)) {
                        //return 'false11111111111';
                        Yii::$app->session->setFlash('error_percentage_criteria', 'You are not full filling minium percentage criteria of CSIR.');
                        $returnCheck = 1;
                    }
                } else if (($castCategoryCode == 'GENERAL') || ($castCategoryCode == 'GENEWS')) {
                    if (($marksPercentage['graduate_marks'] != '') && ($marksPercentage['graduate_marks'] < 55)) {
                        //return 'false11111111111';
                        Yii::$app->session->setFlash('error_percentage_criteria', 'You are not full filling minium percentage criteria of CSIR.');
                        $returnCheck = 1;
                    }
                    if (($marksPercentage['pg_marks']) && ($marksPercentage['pg_marks'] < 55)) {
                        //return 'false11111111111';
                        Yii::$app->session->setFlash('error_percentage_criteria_pg', 'You are not full filling minium percentage criteria of CSIR.');
                        $returnCheck = 1;
                    }
                }
            }
            //If PG is ‘Passed’ then Graduation should be also be ‘Passed‘. Omly PG marks will be validated .
            else if ((($pgPassStatus == 1) && ($graduatePassStatus == 1))) {
                //if(($castCategoryCode == 'OBCNCL') || ($castCategoryCode == 'ST') || ($castCategoryCode == 'SC') || ($IsPwd == 'yes') || ($genderCode == 'THRDGEN')){
                if (($castCategoryCode == 'OBCNCL') || ($castCategoryCode == 'ST') || ($castCategoryCode == 'SC') || ($IsPwd == 'yes')) {
                    //                    if(($marksPercentage['graduate_marks'] != '') && ($marksPercentage['graduate_marks'] < 50)){
                    //                        //return 'false11111111111';
                    //                        Yii::$app->session->setFlash('error_percentage_criteria', 'You are not full filling minium percentage criteria of CSIR.');
                    //                         $returnCheck=1;
                    //                    }
                    if (($marksPercentage['pg_marks']) && ($marksPercentage['pg_marks'] < 50)) {
                        //return 'false11111111111';
                        Yii::$app->session->setFlash('error_percentage_criteria_pg', 'You are not full filling minium percentage criteria of CSIR.');
                        $returnCheck = 1;
                    }
                } else if (($castCategoryCode == 'GENERAL') || ($castCategoryCode == 'GENEWS')) {
                    //                    if(($marksPercentage['graduate_marks'] != '') && ($marksPercentage['graduate_marks'] < 55)){
                    //                        //return 'false11111111111';
                    //                        Yii::$app->session->setFlash('error_percentage_criteria', 'You are not full filling minium percentage criteria of CSIR.');
                    //                         $returnCheck=1;
                    //                    }
                    if (($marksPercentage['pg_marks']) && ($marksPercentage['pg_marks'] < 55)) {
                        //return 'false11111111111';
                        Yii::$app->session->setFlash('error_percentage_criteria_pg', 'You are not full filling minium percentage criteria of CSIR.');
                        $returnCheck = 1;
                    }
                }
            }
        }
        //For LS-Assistance:
        if ($isJrfOpt == 'no') {
            if ($pgPassStatus == 1) {
                //if(($castCategoryCode == 'OBCNCL') || ($castCategoryCode == 'ST') || ($castCategoryCode == 'SC') || ($IsPwd == 'yes') || ($genderCode == 'THRDGEN')){
                if (($castCategoryCode == 'OBCNCL') || ($castCategoryCode == 'ST') || ($castCategoryCode == 'SC') || ($IsPwd == 'yes')) {
                    if (isset($marksPercentage['pg_marks']) && ($marksPercentage['pg_marks'] < 50)) {
                        Yii::$app->session->setFlash('error_percentage_criteria_pg', 'You are not full filling minium percentage criteria of CSIR.');
                        $returnCheck = 1;
                    }
                } else if (($castCategoryCode == 'GENERAL') || ($castCategoryCode == 'GENEWS')) {
                    if (isset($marksPercentage['pg_marks']) && ($marksPercentage['pg_marks'] < 55)) {
                        Yii::$app->session->setFlash('error_percentage_criteria_pg', 'You are not full filling minium percentage criteria of CSIR.');
                        $returnCheck = 1;
                    }
                }
                if ($IsPgCourseMSPhD == 'yes') {
                    if (isset($marksPercentage['pg_marks']) && ($marksPercentage['pg_marks'] < 50)) {
                        Yii::$app->session->setFlash('error_percentage_criteria_pg', 'You are not full filling minium percentage criteria of CSIR.');
                        $returnCheck = 1;
                    }
                }
            }
        }
        return $returnCheck;
    }

    public function IsCandValidQualificationDetails()
    {
        $CandidateID = Yii::$app->user->identity->ID;
        $candAppliedCourse = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'ID,ApplyCourseID')
            ->bindValue(':input', "WHERE IsActive=1 AND CandidateID=$CandidateID")
            ->bindValue(':table', 'CandidateApplyCourseTbl')
            ->queryOne();

        if (isset($candAppliedCourse) && !empty($candAppliedCourse)) {
            $CandApplyCourseID = $candAppliedCourse['ApplyCourseID'];
            $candCourse = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
                ->bindValue(':select', 'ID,CourseCode')
                ->bindValue(':input', "WHERE IsActive=1 AND ID=$CandApplyCourseID")
                ->bindValue(':table', 'CourseMst')
                ->queryOne();
            $candPassStatus = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
                ->bindValue(':select', 'ID,PassStatus')
                ->bindValue(':input', "WHERE IsActive=1 AND CandidateID=$CandidateID ")
                ->bindValue(':table', 'CandidateQualificationDetailsTbl')
                ->queryOne();
            if (isset($candCourse, $candCourse['CourseCode'], $candPassStatus, $candPassStatus['PassStatus']) && !empty($candCourse) && !empty($candPassStatus)) {
                //$IsCandLsCourseOpt = 'no';
                if ($candCourse['CourseCode'] == 'C001') { //For L.S. Courese Opted:
                    //$IsCandLsCourseOpt = 'yes';
                    if ($candPassStatus['PassStatus'] == 2) {
                        return 0;
                    }
                }
                return 1;
            } else {
                return 0;
            }
        }
    }

    public function checkArtisanCandidate()
    {
        $ID = Yii::$app->user->identity->ID;
        $data = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'CandAst.SubjecSpecializationMstID')
            ->bindValue(':input', "left join CandidateApplySubjectTbl AS CandAst on Cand.ID = CandAst.CandidateID WHERE Cand.RegisteredDate < '2024-01-18' and CandAst.SubjecSpecializationMstID = '10074' and Cand.ID= $ID")
            ->bindValue(':table', 'CandidateTbl AS Cand')
            ->queryOne();
        return $data;
    }

    public function dayArray()
    {
        $DobDay = array();
        for ($i = 1; $i <= 31; $i++) {
            $DobDay[str_pad($i, 2, '0', STR_PAD_LEFT)] = str_pad($i, 2, '0', STR_PAD_LEFT);
        }
        return $DobDay;
    }

    public function monthArray()
    {
        $DobMonth = array();
        for ($m = 1; $m <= 12; ++$m) {
            $DobMonth[str_pad($m, 2, '0', STR_PAD_LEFT)] = date('F', mktime(0, 0, 0, $m, 1));
        }
        return $DobMonth;
    }

    public function yearArray()
    {
        //$examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-18 year");
        $examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-" . yii::$app->params['ageMin'] . " year");
        $MinYear = date('Y', ($examDate));
        //$examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-35 year");
        $examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-" . yii::$app->params['ageMax'] . " year");
        $MaxYear = date('Y', ($examDate));

        $DobYear = array();
        for ($year = $MaxYear; $year <= $MinYear; $year++) {
            $DobYear[$year] = $year;
        }
        return $DobYear;
    }

    public function yearArrayArtisan()
    {
        // //$examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-18 year");
        // $examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-" . yii::$app->params['ageMin'] . " year");
        // $MinYear = date('Y', ($examDate));
        // //$examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-35 year");
        // $examDate = strtotime(date('Y-m-d', strtotime(yii::$app->params['examStartDate'])) . "-" . yii::$app->params['ageMax'] . " year");
        // $MaxYear = date('Y', ($examDate));

        $DobYear = array();
        for ($year = 1945; $year <= 2024; $year++) {
            $DobYear[$year] = $year;
        }
        return $DobYear;
    }

    
    public function getPaymentButtonDisableStatus()
    {
        $CandidateID=yii::$app->user->identity->ID;
        $ApplicationNumber=yii::$app->user->identity->ApplicationNumber;
        $PaymentButtonDisable=0;

        $PaymentDetails = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
            ->bindValue(':select', '*')
            ->bindValue(':input', "Where CandidateID = $CandidateID and ApplicationNumber='$ApplicationNumber'")
            ->bindValue(':orderBy', 'order by PaymentSubmitDate DESC')
            ->bindValue(':table', 'PaymentTranscationTbl')
            ->queryOne();
        if(isset($PaymentDetails,$PaymentDetails['PaymentSubmitDate'])  && !empty($PaymentDetails)){
            $PaymentSubmitDateTime =  $PaymentDetails['PaymentSubmitDate'] ;
            $PaymentSubmitDateTime = strtotime($PaymentSubmitDateTime);
            $CurrentDateTime = date('Y-m-d H:i:s');
            $CurrentDateTime = strtotime($CurrentDateTime);
            $DiffInMins =(INT) round(abs($CurrentDateTime - $PaymentSubmitDateTime) / 60,2);
            $PaymentDisableTimeInMins = Yii::$app->params['PaymentDisableTimeInMins'];

            if($DiffInMins < $PaymentDisableTimeInMins){
                $PaymentButtonDisable = 1;
            }
            return  $PaymentButtonDisable;
        }
        return  $PaymentButtonDisable;
    }

    public function getPaymentButtonDisableRemainingTime()
    {

        $CandidateID=yii::$app->user->identity->ID;
        $ApplicationNumber=yii::$app->user->identity->ApplicationNumber;
        $PayBtnDisableRemainingTime=0;

        $PaymentDetails = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table, :orderBy")
            ->bindValue(':select', '*')
            ->bindValue(':input', "Where CandidateID = $CandidateID and ApplicationNumber='$ApplicationNumber'")
            ->bindValue(':orderBy', 'order by PaymentSubmitDate DESC')
            ->bindValue(':table', 'PaymentTranscationTbl')
            ->queryOne();
        if(isset($PaymentDetails,$PaymentDetails['PaymentSubmitDate'])  && !empty($PaymentDetails)){
            $PaymentSubmitDateTime =  $PaymentDetails['PaymentSubmitDate'] ;
            $PaymentSubmitDateTime = strtotime($PaymentSubmitDateTime);
            $CurrentDateTime = date('Y-m-d H:i:s');
            $CurrentDateTime = strtotime($CurrentDateTime);
            $DiffInMins =(INT) round(abs($CurrentDateTime - $PaymentSubmitDateTime) / 60,2);
            $PaymentDisableTimeInMins = Yii::$app->params['PaymentDisableTimeInMins'];
            $PayBtnDisableRemainingTime = $PaymentDisableTimeInMins - $DiffInMins;
        }
        return  $PayBtnDisableRemainingTime;
    }


    public function getCorrectionDataByCol($ColumName=NULL)
    {
        $CandidateID = Yii::$app->user->identity->ID;

        if(isset($CandidateID,$ColumName) && !empty($CandidateID) && !empty($ColumName)){

            $CandidateDataArray = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', $ColumName)
            ->bindValue(':input', 'WHERE IsActive=1 and CandidateID=' . $CandidateID)
            ->bindValue(':table', 'CandidateCorrectionDataTbl')
            ->queryOne();

            if (isset($CandidateDataArray, $CandidateDataArray[$ColumName]) && !empty($CandidateDataArray) && !empty($CandidateDataArray[$ColumName])) {
               
                $CandidateDetailsData = json_decode($CandidateDataArray[$ColumName], true);
                return $CandidateDetailsData;

            }else{
                return 0;
            }
        }else{
            return 0;
        }
    }

    public function getCandidateIP(){
        $CandidateIP =   'Unknown';
        if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
            $CandidateIP = $_SERVER['HTTP_CLIENT_IP'];
        } else if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $CandidateIP = $_SERVER['HTTP_X_FORWARDED_FOR'];
        } else {
            $CandidateIP = $_SERVER['REMOTE_ADDR'];
        }
        return $CandidateIP;
    }


}
