<?php

namespace common\components;

use Yii;
use yii\base\Component;
use common\models\ApplicationWindow;

class PaymentCalculationComponent extends Component
{
    
    public function getExamFeeByCandidateCastCategory()
    {
        // return 1;

        $response = array('Status' => 'Error', 'TotalPayableAmount' => 0);
      
        $CandidateID = Yii::$app->user->identity->ID;
        $CastCategoryID = Yii::$app->user->identity->CastCategoryID;
        $Pwd = Yii::$app->user->identity->PhysicalDisability;
        $GenderID = Yii::$app->user->identity->GenderID;


        $applicationStatus = Yii::$app->ApplicationOpen->Openwindow();
        $correctionStatus = Yii::$app->CorrectionWindow->Openwindow();

        if (isset($applicationStatus, $correctionStatus) && ($applicationStatus == 0) && ($correctionStatus == 1)) {

            $PersonalDetailsDataArray = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
                ->bindValue(':select', 'PersonalDetails')
                ->bindValue(':input', 'WHERE IsActive=1 and CandidateID=' . $CandidateID)
                ->bindValue(':table', 'CandidateCorrectionDataTbl')
                ->queryOne();

            if (isset($PersonalDetailsDataArray, $PersonalDetailsDataArray['PersonalDetails']) && !empty($PersonalDetailsDataArray) && !empty($PersonalDetailsDataArray['PersonalDetails'])) {
                $PersonalDetailsData = json_decode($PersonalDetailsDataArray['PersonalDetails'], true);
                //  echo '<pre>';
                //  print_r($PersonalDetailsData);die;

                $GenderID=$PersonalDetailsData['GenderID'] ?? yii::$app->user->identity->GenderID;
                $CastCategoryID=$PersonalDetailsData['CastCategoryID'] ?? yii::$app->user->identity->CastCategoryID;
                $Pwd=$PersonalDetailsData['PhysicalDisability'] ?? yii::$app->user->identity->PhysicalDisability;

            }

        }

    

        $CandCastCategoryData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', '*')
            ->bindValue(':input', "WHERE ID=$CastCategoryID")
            ->bindValue(':table', 'CasteCategoryMst')
            ->queryOne();

        $CandGenderData = Yii::$app->db->createCommand("exec getCommonDataSP :select, :input, :table")
            ->bindValue(':select', 'GenderCode')
            ->bindValue(':input', "WHERE ID=$GenderID")
            ->bindValue(':table', 'GenderMst')
            ->queryOne();

        if (isset($CandCastCategoryData) && !empty($CandCastCategoryData) && isset($CandGenderData) && !empty($CandGenderData)) {
            $cand_is_pwd = (($Pwd == 1) || ($Pwd == 2)) ? 'yes' : 'no';
            $cand_cast_category = $CandCastCategoryData['CategoryCode'];
            $cand_gender = $CandGenderData['GenderCode'];

            //Exam Fee by Cas Category Params:
            $ExamFee_General = yii::$app->params['ExamFee_General'];
            $ExamFee_GeneralEws_ObcNcl = yii::$app->params['ExamFee_GeneralEws_ObcNcl'];
            $ExamFee_Sc_St = yii::$app->params['ExamFee_Sc_St'];
            //$ExamFee_ThirdGender = yii::$app->params['ExamFee_ThirdGender'];
            $ExamFee_Pwd = yii::$app->params['ExamFee_Pwd'];

            if ($cand_is_pwd == 'yes') {
                // return number_format($ExamFee_Pwd, 2, '.', '');
                $payableAmount = number_format($ExamFee_Pwd, 2, '.', '');
                return array('Status' => 'Success', 'TotalPayableAmount' => $payableAmount);
            } 
            else if ($cand_cast_category == 'GENERAL') {
                // return number_format($ExamFee_General, 2, '.', '');
                $payableAmount = number_format($ExamFee_General, 2, '.', '');
                return array('Status' => 'Success', 'TotalPayableAmount' => $payableAmount);
            } 
            else if (($cand_cast_category == 'GENEWS') || ($cand_cast_category == 'OBCNCL')) {
                // return number_format($ExamFee_GeneralEws_ObcNcl, 2, '.', '');
                $payableAmount = number_format($ExamFee_GeneralEws_ObcNcl, 2, '.', '');
                return array('Status' => 'Success', 'TotalPayableAmount' => $payableAmount);
            } 
            else if (($cand_cast_category == 'SC') || ($cand_cast_category == 'ST')) {
                // return number_format($ExamFee_Sc_St, 2, '.', '');
                $payableAmount = number_format($ExamFee_Sc_St, 2, '.', '');
                return array('Status' => 'Success', 'TotalPayableAmount' => $payableAmount);
            }
            return $response;
        }
        return $response;
    }

}
