<?php
return [
    'timeZone' => 'Asia/Calcutta',
    'aliases' => [
        '@bower' => '@vendor/bower-asset',
        '@npm'   => '@vendor/npm-asset',
    ],
    'vendorPath' => dirname(dirname(__DIR__)) . '/vendor',
    'components' => [
        'cache' => [
            'class' => \yii\caching\FileCache::class,
        ],
        'facedetect' => [
            'class' => 'common\components\FacedetectionComponent',
        ],
        'SanatizeInput' => [
            'class' => 'common\components\SanatizeInputComponent',
        ],
        'encryptdecrypt' => [
            'class' => 'common\components\EncryptdecryptComponent',
        ],
        'globalfunction' => [
            'class' => 'common\components\GlobalFunctionComponent',
        ],
        'DuplicateCandidateCheck' => [
            'class' => 'common\components\DuplicateCandidateComponent',
        ],
        
    ],
    'controllerMap' => [
        'fixture' => [
            'class' => \yii\console\controllers\FixtureController::class,
            'namespace' => 'common\fixtures',
        ],
        'serve' => [
            'class' => yii\console\controllers\ServeController::class,
            'docroot' => '@frontend/web',
        ],
        'migration' => [
            'class' => 'bizley\migration\controllers\MigrationController',
        ],
    ],
];
