<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "ActivityLogsTbl".
 *
 * @property int $ID
 * @property int|null $ActivityModuleID
 * @property string|null $PageURL
 * @property string|null $UserIP
 * @property int|null $CandidateID
 * @property int|null $IsActive
 * @property string|null $CreatedDate
 * @property int|null $ActivityID
 *
 * @property ActivityMst $activity
 * @property ActivityModuleMst $activityModule
 */
class ActivityLogsTbl extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'ActivityLogsTbl';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['ActivityModuleID', 'CandidateID', 'IsActive', 'ActivityID'], 'integer'],
            [['CreatedDate'], 'safe'],
            [['PageURL'], 'string', 'max' => 250],
            [['UserIP'], 'string', 'max' => 30],
            [['ActivityModuleID'], 'exist', 'skipOnError' => true, 'targetClass' => ActivityModuleMst::class, 'targetAttribute' => ['ActivityModuleID' => 'ID']],
            [['ActivityID'], 'exist', 'skipOnError' => true, 'targetClass' => ActivityMst::class, 'targetAttribute' => ['ActivityID' => 'ID']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'ID' => 'ID',
            'ActivityModuleID' => 'Activity Module ID',
            'PageURL' => 'Page Url',
            'UserIP' => 'User Ip',
            'CandidateID' => 'Candidate ID',
            'IsActive' => 'Is Active',
            'CreatedDate' => 'Created Date',
            'ActivityID' => 'Activity ID',
        ];
    }

    /**
     * Gets query for [[Activity]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getActivity()
    {
        return $this->hasOne(ActivityMst::class, ['ID' => 'ActivityID']);
    }

    /**
     * Gets query for [[ActivityModule]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getActivityModule()
    {
        return $this->hasOne(ActivityModuleMst::class, ['ID' => 'ActivityModuleID']);
    }
}
