<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "ActivityModuleMst".
 *
 * @property int $ID
 * @property string|null $ModuleName
 * @property int|null $IsActive
 * @property string|null $CreatedDate
 *
 * @property ActivityLogsTbl[] $activityLogsTbls
 */
class ActivityModuleMst extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'ActivityModuleMst';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['ModuleName'], 'string'],
            [['IsActive'], 'integer'],
            [['CreatedDate'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'ID' => 'ID',
            'ModuleName' => 'Module Name',
            'IsActive' => 'Is Active',
            'CreatedDate' => 'Created Date',
        ];
    }

    /**
     * Gets query for [[ActivityLogsTbls]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getActivityLogsTbls()
    {
        return $this->hasMany(ActivityLogsTbl::class, ['ActivityModuleID' => 'ID']);
    }
}
