<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "ActivityMst".
 *
 * @property int $ID
 * @property string|null $ActivityName
 * @property int|null $IsActive
 * @property string|null $CreatedDate
 *
 * @property ActivityLogsTbl[] $activityLogsTbls
 */
class ActivityMst extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc} 
     */
    public static function tableName()
    {
        return 'ActivityMst';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['IsActive'], 'integer'],
            [['CreatedDate'], 'safe'],
            [['ActivityName'], 'string', 'max' => 250],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'ID' => 'ID',
            'ActivityName' => 'Activity Name',
            'IsActive' => 'Is Active',
            'CreatedDate' => 'Created Date',
        ];
    }

    /**
     * Gets query for [[ActivityLogsTbls]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getActivityLogsTbls()
    {
        return $this->hasMany(ActivityLogsTbl::class, ['ActivityID' => 'ID']);
    }
}
