<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "CandidateLandingMst".
 *
 * @property int $ID
 * @property string|null $ApplicationNumber
 * @property string|null $DBName
 * @property string|null $EmailId
 * @property int|null $IsActive
 * @property string|null $CreatedDate
 */
class CandidateLandingMst extends \yii\db\ActiveRecord
{
     public $CandidateName;
     public $EmailId;
     public $ConfirmCandidateEmail;
     public $GenderID;
     public $CandidateMobile;
     public $ConfirmCandidateMobile;
     public $IdentityID;
     public $IdentityNumber;
     public $StateID;
     public $Password;
     public $ConfirmPassword;
     public $SecurityQuestionID;
     public $SecurityAnswer;
     public $verifyCode;
     public $IsCheckedName;
     public $IsCheckedMobile;
     public $IsCheckedEmail;
     public $IsConfirm;
     public $PremisesName;
     public $SubLocality;
     public $Locality;
     public $CountryID;
     public $StateUTID;
     public $DistrictID;
     public $PinCode;
     public $PermanentPremisesName;
     public $PermanentSubLocality;
     public $PermanentLocality;
     public $PermanentCountryID;
     public $PermanentStateUTID;
     public $PermanentDistrictID;
     public $PermanentPinCode;
     public $FatherName;
     public $MotherName;
     public $Day;
     public $Month;
     public $Year;
     public $checkboxName;
     public $AlternateMobile;
     public $IsCheckedFather;
     public $IsCheckedMother;
     public $IsCheckedDOB;
     public $IsCheckedGender;

    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'CandidateLandingMst';
    }

    /**
     * @return \yii\db\Connection the database connection used by this AR class.
     */

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['CandidateName', 'EmailId', 'ConfirmCandidateEmail', 'GenderID', 'CandidateMobile', 'ConfirmCandidateMobile', 'IdentityID', 'IdentityNumber', 'Password', 'ConfirmPassword', 'SecurityQuestionID', 'SecurityAnswer', 'verifyCode', 'PremisesName', 'Locality', 'CountryID', 'StateUTID', 'DistrictID', 'PinCode', 'PermanentPremisesName', 'PermanentLocality', 'PermanentCountryID', 'PermanentStateUTID', 'PermanentDistrictID', 'PermanentPinCode', 'FatherName', 'MotherName', 'Day', 'Month', 'Year' ], 'required', 'message' => '{attribute} is required.'],
           // [['CandidateName', 'EmailId', 'ConfirmCandidateEmail', 'GenderID', 'CandidateMobile', 'ConfirmCandidateMobile', 'IdentityID', 'IdentityNumber', 'Password', 'ConfirmPassword', 'SecurityQuestionID', 'SecurityAnswer', 'verifyCode', 'PremisesName', 'Locality', 'CountryID', 'StateUTID', 'DistrictID', 'PinCode', 'PermanentPremisesName', 'PermanentLocality', 'PermanentCountryID', 'PermanentStateUTID', 'PermanentDistrictID', 'PermanentPinCode', 'FatherName', 'MotherName', 'Day', 'Month', 'Year'], 'trim'],
            [['CandidateName', 'SecurityAnswer', 'EmailId', 'ConfirmCandidateEmail'], 'string', 'min' => 2, 'max' => 100],
            [
                ['CandidateName', 'SecurityAnswer', 'FatherName', 'MotherName'],
                'match', 'pattern' => "/^(?!.*['-]{2})[a-zA-Z][a-zA-Z'\s-]{1,100}$/",
                'message' => '{attribute} is not valid character'
            ],
            [
                ['CandidateMobile', 'ConfirmCandidateMobile', 'AlternateMobile'],
                'match', 'pattern' => "/^[0-9]{10}$/",
                'message' => 'Please enter only numeric value and should be 10 digits.'
            ],
            [['CandidateMobile', 'ConfirmCandidateMobile', 'AlternateMobile'], 'string', 'min' => 10, 'max' => 10, 'message' => '{attribute} valid  number.'],
            [
                ['Password'],
                'string', 'min' => 8, 'max' => 13, 'message' => 'Password length should be between 8 to 13 digit.'
            ],
            [
                ['ConfirmPassword'],
                'string', 'min' => 8, 'max' => 13, 'message' => 'ConfirmPassword length should be between 8 to 13 digit.'
            ],
            [
                ['Password'],
                'match', 'pattern' => '/(?=^.{8,13}$)(?=.{0,}[A-Z])(?=.{0,}[a-z])(?=.{0,}\W)(?=.{0,}\d)/',
                'message' => '{attribute} is not valid character'
            ],
            [['EmailId', 'ConfirmCandidateEmail'], 'email'],
            [['EmailId'], 'unique', 'message' => 'Candidate email address already exists.'],
            [['verifyCode'], 'captcha', 'captchaAction' => '/Auth/registration/captcha'],
            ['ConfirmPassword', 'compare', 'compareAttribute' => 'Password', 'message' => 'Password Not Matched.'],
            ['ConfirmCandidateEmail', 'compare', 'compareAttribute' => 'EmailId', 'message' => 'Email id Not Matched.'],
            ['ConfirmCandidateMobile', 'compare', 'compareAttribute' => 'CandidateMobile', 'message' => 'Mobile number and confirm mobile number should be same.'],
            ['AlternateMobile', 'compare', 'compareAttribute' => 'CandidateMobile', 'operator' => '!=', 'message' => 'Mobile number and alternate mobile number should not be same.'],
            [['IsCheckedName'], 'required', 'requiredValue' => 1, 'message' => 'This field is required'],
            [['IsCheckedMobile'], 'required', 'requiredValue' => 1, 'message' => 'This field is required'],
            [['IsCheckedEmail'], 'required', 'requiredValue' => 1, 'message' => 'This field is required'],
            [['IsCheckedFather'], 'required', 'requiredValue' => 1, 'message' => 'This field is required'],
            [['IsCheckedMother'], 'required', 'requiredValue' => 1, 'message' => 'This field is required'],
            [['IsCheckedDOB'], 'required', 'requiredValue' => 1, 'message' => 'This field is required'],
            [['IsConfirm'], 'required', 'requiredValue' => 1, 'message' => 'This field is required'],
            [['IsCheckedGender'], 'required', 'requiredValue' => 1, 'message' => 'This field is required'],
            [
                'IdentityNumber', 'match', 'pattern' => "/^([a-zA-Z]){5}([0-9]){4}([a-zA-Z]){1}?$/", 'message' => 'Please enter valid PAN Number(example:-BNZAA2318J).', 'when' => function ($model) {
                    return $model->IdentityID == 1;
                }, 'whenClient' => "function (attribute, value) { return $('#Identity_ID').val() == 1}"
            ],
            [
                'IdentityNumber', 'match', 'pattern' => "/^[A-Z]{3}[0-9]{7}$/", 'message' => 'Please enter valid VOTER ID (example:- XGN3002623).', 'when' => function ($model) {
                    return $model->IdentityID == 2;
                }, 'whenClient' => "function (attribute, value) { return $('#Identity_ID').val() == 2}"
            ],
            [
                'IdentityNumber', 'match', 'pattern' => "/^(([A-Z]{2}[0-9]{2})( )|([A-Z]{2}-[0-9]{2}))((19|20)[0-9][0-9])[0-9]{7}$/", 'message' => 'Please enter valid DRIVING LICENCE (example:-UP14 20160034761).', 'when' => function ($model) {
                    return $model->IdentityID == 3;
                }, 'whenClient' => "function (attribute, value) { return $('#Identity_ID').val() == 3}"
            ],
            [
                'IdentityNumber', 'match', 'pattern' => "/^([a-zA-Z0-9]){8,12}\s*$/", 'message' => 'Please enter valid RATION CARD Number (example:-fafaafaf8989).', 'when' => function ($model) {
                    return $model->IdentityID == 4;
                }, 'whenClient' => "function (attribute, value) { return $('#Identity_ID').val() == 4}"
            ], //^\d{4}\s\d{4}\s\d{4}$
            [
                'IdentityNumber', 'match', 'pattern' => "/^[A-PR-WY][1-9]\d\s?\d{4}[1-9]$/", 'message' => 'Please enter valid passport number (example:-A21 90457).', 'when' => function ($model) {
                    return $model->IdentityID == 5;
                }, 'whenClient' => "function (attribute, value) { return $('#Identity_ID').val() == 5}"
            ], //var regex = /[a-zA-Z]{3}[PCHFATBLJG]{1}[a-zA-Z]{1}[0-9]{4}[a-zA-Z]{1}$/;
            [
                'IdentityNumber', 'match', 'pattern' => "/^(?=.*[a-zA-Z0-9])(?=.*[0-9])[A-Za-z0-9]+.{3,36}$/",  'message' => 'Please enter valid Document Issued By Govt Authority Number(example:-Enter character or numeric min 3 , max 36).', 'when' => function ($model) {
                    return $model->IdentityID == 6;
                }, 'whenClient' => "function (attribute, value) { return $('#Identity_ID').val() == 6}"
            ],
            [['PremisesName', 'Locality', 'CountryID', 'StateUTID', 'DistrictID',  'PinCode', 'PermanentPremisesName', 'PermanentLocality', 'PermanentCountryID', 'PermanentStateUTID', 'PermanentDistrictID', 'PermanentPinCode'], 'required'],
            [['CreateDate'], 'safe'],
            [['PremisesName', 'PermanentPremisesName'], 'string', 'max' => 150, 'min' => 2],
            [['SubLocality', 'Locality', 'PermanentLocality', 'PermanentSubLocality'], 'string', 'max' => 100, 'min' => 2],
            //[['PinCode','PermanentPinCode'],'match', 'pattern' => "/^[0-9a-zA-Z]{6}$/", 'message' => 'Please enter valid pincode'],
            [
                ['PinCode', 'PermanentPinCode'], function ($attribute, $params) {
                    if ($this->CountryID == 101) {
                        return 'integer';
                    } else {
                        return 'string';
                    }
                }
            ],
            [['PinCode', 'PermanentPinCode'], 'string', 'max' => 6, 'min' => 6],
            //[['CandidateID'], 'exist', 'skipOnError' => true, 'targetClass' => CandidateTbl::class, 'targetAttribute' => ['CandidateID' => 'ID']],
            //[['CountryID'], 'exist', 'skipOnError' => true, 'targetClass' => CountryMst::class, 'targetAttribute' => ['CountryID' => 'ID']],
           // [['StateUTID'], 'exist', 'skipOnError' => true, 'targetClass' => StateMst::class, 'targetAttribute' => ['StateUTID' => 'ID']],
           // [['DistrictID'], 'exist', 'skipOnError' => true, 'targetClass' => DistrictMst::class, 'targetAttribute' => ['DistrictID' => 'ID']],

            //[['PermanentCountryID'], 'exist', 'skipOnError' => true, 'targetClass' => CountryMst::class, 'targetAttribute' => ['PermanentCountryID' => 'ID']],
            //[['PermanentDistrictID'], 'exist', 'skipOnError' => true, 'targetClass' => DistrictMst::class, 'targetAttribute' => ['PermanentDistrictID' => 'ID']],

            [
                'PinCode', 'match', 'pattern' => "/^[0-9]+$/", 'message' => 'Pin code should be numeric and 6 characters long.', 'when' => function ($model) {
                    return $model->CountryID == 101;
                }, 'whenClient' => "function (attribute, value) { return $('#pr_CountryID').val() == 101}"
            ],

            [
                'PermanentPinCode', 'match', 'pattern' => "/^[0-9]+$/", 'message' => 'Pin code should be numeric and 6 characters long.', 'when' => function ($model) {
                    return $model->CountryID == 101;
                }, 'whenClient' => "function (attribute, value) { return $('#pr_CountryID').val() == 101}"
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'CandidateName' => 'Candidate Name ',
            'EmailId' => 'Email Address ',
            'ConfirmCandidateEmail' => 'Confirm Email Address',
            'GenderID' => 'Gender',
            'CandidateMobile' => 'Mobile Number',
            'ConfirmCandidateMobile' => 'Confirm Mobile Number',
            'IdentityID' => 'Identity Type',
            'IdentityNumber' => 'Identification Number',
            'StateID' => 'State',
            'Password' => 'Password',
            'Password' => 'Password',
            'ConfirmPassword' => 'Confirm Password',
            'SecurityQuestionID' => 'Security Question',
            'SecurityAnswer' => 'Security Answer',
            'verifyCode' => 'Security Pin',
            'PermanentCountryID' => 'Permanent Country ',
            'PermanentStateUTID' => 'Permanent State ',
            'PermanentDistrictID' => 'Permanent District',
            'PermanentPinCode' => 'Permanent Pincode',
            'CountryID' => 'Present Country ',
            'StateUTID' => 'Present State ',
            'DistrictID' =>'Present District',
            'PinCode' =>   'Present Pincode',
            
        ];
    }
}
