<?php

namespace common\models;

use Yii;
use yii\base\Model;
use app\modules\application\models\CandidateTbl;
use Nullix\CryptoJsAes\CryptoJsAes;
/**
 * Login form
 */
class LoginForm extends Model
{
   // public $email;
    public $ApplicationNumber;
    public $Password;
    public $rememberMe = true;

    private $_user;
    public $verifyCode;

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            // username and password are both required
            [['ApplicationNumber', 'Password'], 'required'],
            [
                ['ApplicationNumber', 'verifyCode'],
                'match', 'pattern' => "/^[0-9]+$/",
                'message' => '{attribute} should contain only numeric value.'
            ],
            [['ApplicationNumber'], 'string', 'min' => 12, 'max' => 30],
            // rememberMe must be a boolean value
            ['rememberMe', 'boolean'],
            // password is validated by validatePassword()
            ['Password', 'validatePassword'],
            // verifyCode needs to be entered correctly
            ['verifyCode', 'captcha'],
        ];
    }

    public function attributeLabels()
    {
        return [
            'verifyCode' => 'Verification Code',
        ];
    }
    /**
     * Validates the password.
     * This method serves as the inline validation for password.
     *
     * @param string $attribute the attribute currently being validated
     * @param array $params the additional name-value pairs given in the rule
     */
    public function validatePassword($attribute, $params)
    {
        if (!$this->hasErrors()) {
            $str1 = substr($this->Password, 6);
            $subLast    = substr($str1, 0, -6);
            $decodepassword =  base64_decode($subLast);
            $PasswordNew    =   base64_decode($decodepassword);
            $user = $this->getUser();
            if (!$user) {
                $this->addError('ApplicationNumberE', 'No such application no. or password.');//Incorrect application number
                return false;
//                $this->addError('ApplicationNumber', 'Incorrect application number.');
//                return false;
            }else if (!$user->validatePassword($PasswordNew)) {
                $this->addError('ApplicationNumberE', 'No such application no. or password.');
                //$this->addError($attribute, 'Incorrect application password.');
            }
        }
    }

    /**
     * Logs in a user using the provided email and password.
     *
     * @return bool whether the user is logged in successfully
     */
    public function login()
    { 
        if ($this->validate()) {
            return Yii::$app->user->login($this->getUser(), $this->rememberMe ? 3600 * 24 * 30 : 0);
        }
        
        return false;
    }

    /**
     * Finds user by [[email]]
     *
     * @return User|null
     */
    // protected function getUser()
    // {
    //     if ($this->_user === null) {
    //         $this->_user = User::findByEmail($this->email);
    //     }

    //     return $this->_user;
    // }

        /**
     * Finds user by [[ApplicationNumber]]
     *
     * @return User|null
     */
    protected function getUser()
    {
        $condidate =  CandidateTbl::find()->where(['ApplicationNumber' => $this->ApplicationNumber])->one();
       
        if ($condidate != null) {
            $condidate->LastLoginDate = date('Y-m-d h:i:s');
            $condidate->save();
        }
        if ($this->_user === null) {
            $this->_user = User::findByApplicationNo($this->ApplicationNumber);
        }

        return $this->_user;
    }
}
