<?php

namespace common\models;

use Yii;
use yii\base\Model;
use common\models\User;

/**
 * Password reset request form
 */
class PasswordResetRequestForm extends Model
{
    public $CandidateEmail;
    public $ApplicationNumber;
    public $CandidateMobile;
    public $SecurityQuestion;
    public $SecurityAnswer;
    public $selectOption;
    public $ApplicationNumberMobile;
    public $EmailOtp;
    public $MobileOtp;
    public $OTPWinShow;
    public $CandidateEmailID;
    public $CandidateID;
    public $OtpExpTime;
    public $ApplicationNumberEmail;
    public $verifyCode;

    /**
     * {@inheritdoc}
     */
    public function rules()
    {

        return [
            ['selectOption', 'required'],
            ['verifyCode', 'captcha', 'captchaAction' => '/Auth/registration/captcha'],
            ['CandidateEmail', 'trim'],
            ['CandidateEmail', 'email'],
            // ['CandidateEmail', 'exist',
            //     'targetClass' => '\common\models\User',
            //     'filter' => ['Status' => User::STATUS_ACTIVE],
            //     'message' => 'There is no user with this email address.'
            // ],
            [['ApplicationNumber'], 'filter', 'filter' => 'trim'],
            [['ApplicationNumberMobile'], 'filter', 'filter' => 'trim'],
            [['ApplicationNumber'], 'match', 'pattern' => "/^(?=.*[a-zA-Z0-9])(?=.*[0-9])[A-Za-z0-9]+$/", 'message' => 'Application Number should be alphanumeric.'],
            [['ApplicationNumberMobile'], 'match', 'pattern' => "/^(?=.*[a-zA-Z0-9])(?=.*[0-9])[A-Za-z0-9]+$/", 'message' => 'Application Number should be alphanumeric.'],
            [['CandidateMobile'], 'match', 'pattern' => "/^(?=.*[0-9])[0-9]+$/", 'message' => 'Candidate Mobile should be Numeric.'],
            [['CandidateMobile'], 'string', 'min' => 10, 'max' => 10],
            [['EmailOtp'], 'match', 'pattern' => "/^(?=.*[0-9])[0-9]+$/", 'message' => 'Email Otp should be Numeric.'],
            [['MobileOtp'], 'match', 'pattern' => "/^(?=.*[0-9])[0-9]+$/", 'message' => 'Mobile Otp should be Numeric.'],
            [['EmailOtp'], 'string', 'min' => 4, 'max' => 4],
            [['MobileOtp'], 'string', 'min' => 4, 'max' => 4],
            [
                'verifyCode',
                'required',
                'message' => 'Verification code cannot be blank.',
                'when' => function ($model) {
                    return $model->ApplicationNumber == 1;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '1'; 
                }"
            ],
            [
                'ApplicationNumber',
                'required',
                'message' => 'Application Number cannot be blank.',
                'when' => function ($model) {
                    return $model->ApplicationNumber == 1;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '1'; 
                }"
            ],
            [
                'SecurityQuestion',
                'required',
                'message' => 'Security Question cannot be blank.',
                'when' => function ($model) {
                    return $model->SecurityQuestion == 1;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '1'; 
                }"
            ],
            [
                'SecurityAnswer',
                'required',
                'message' => 'Security Answer cannot be blank.',
                'when' => function ($model) {
                    return $model->SecurityAnswer == 1;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '1'; 
                }"
            ],
            [
                'ApplicationNumberMobile',
                'required',
                'message' => 'Application Number cannot be blank.',
                'when' => function ($model) {
                    return $model->ApplicationNumberMobile == 2;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '2'; 
                }"
            ],
            [
                'CandidateMobile',
                'required',
                'message' => 'Candidate Mobile cannot be blank.',
                'when' => function ($model) {
                    return $model->CandidateMobile == 2;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '2'; 
                }"
            ],
            [
                'CandidateEmail',
                'required',
                'message' => 'Candidate Email cannot be blank.',
                'when' => function ($model) {
                    return $model->CandidateEmail == 3;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '3'; 
                }"
            ],
            [
                'verifyCode',
                'required',
                'message' => 'Verification code cannot be blank.',
                'when' => function ($model) {
                    return $model->CandidateEmail == 3;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '3'; 
                }"
            ],
            [
                'EmailOtp',
                'required',
                'message' => 'Email Otp cannot be blank.',
                'when' => function ($model) {
                    return $model->EmailOtp == 2;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '2'; 
                }"
            ],
            [
                'MobileOtp',
                'required',
                'message' => 'Mobile Otp cannot be blank.',
                'when' => function ($model) {
                    return $model->MobileOtp == 2;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '2'; 
                }"
            ],
            [
                'ApplicationNumberEmail',
                'required',
                'message' => 'Application Number cannot be blank.',
                'when' => function ($model) {
                    return $model->ApplicationNumberEmail == 3;
                },
                'whenClient' => "function (attribute, value) { 
                    return $('#selectTypeVal :selected').val() == '3'; 
                }"
            ],
        ];
        // return [
        //     ['CandidateEmail', 'trim'],
        //     ['CandidateEmail', 'required'],
        //     ['CandidateEmail', 'email'],
        //     ['CandidateEmail', 'exist',
        //         'targetClass' => '\common\models\User',
        //         'filter' => ['Status' => User::STATUS_ACTIVE],
        //         'message' => 'There is no user with this email address.'
        //     ],
        // ];
    }

    public function attributeLabels()
    {
        return [
            'ID' => 'ID',
            'ApplicationNumber' => 'Application Number',
            'ApplicationNumberMobile' => 'Application Number',
        ];
    }
    /**
     * Sends an email with a link, for resetting the password.
     *
     * @return bool whether the email was send
     */
    public function sendEmail()
    {
        /* @var $user User */
        $user = User::findOne([
            'Status' => User::STATUS_ACTIVE,
            'CandidateEmail' => $this->CandidateEmail,
        ]);

        if (!$user) {
            return false;
        }

        if (!User::isPasswordResetTokenValid($user->PasswordResetToken)) {
            $user->generatePasswordResetToken();
            if (!$user->save()) {
                return false;
            }
        }

        return Yii::$app
            ->mailer
            ->compose(
                ['html' => 'passwordResetToken-html', 'text' => 'passwordResetToken-text'],
                ['user' => $user]
            )
            ->setFrom([Yii::$app->params['supportEmail'] => Yii::$app->name . ' robot'])
            ->setTo($this->CandidateEmail)
            ->setSubject('Password reset for ' . Yii::$app->name)
            ->send();
    }
}
